var search_targets = 
[/*jshint multistr: true */

  ["1 Introduction", [
    ["base", "1001", "Material Definition Language (MDL) enables users to define the reflective, transmissive, emissive and volumetric properties of objects. For details regarding the elemental distribution functions and operations, please see the MDL specification."],
    ["base", "1002", "The module <tt>base.mdl</tt> provides a set of texturing functions covering the whole range from bitmap to procedural texturing. In addition, module <tt>base.mdl</tt> provides helper functions to make some common tasks easy, as well as provide backwards compatibility support for some legacy parameter semantics."]
  ]],
  ["2.1 Texturing functions", [
    ["base", "1003", "The main purpose of the module <tt>mdl</tt> is to provide material creators with a comprehensive set of texturing functions to spatial variations to their materials."],
    ["base", "1004", "The texture functions enable you to add bitmapped textures, various types of procedural patterns, as well as layered combinations of these textures to your material. The coordinate space for these texture nodes defaults to the receiving object's first avg coordinate space. Function names for texturing functions end with <tt>_texture</tt>."],
    ["base", "1005", "All basic texturing functions return a value of type <tt>struct</tt> containing two fields:"],
    ["base", "1006", "<tt>tint</tt>"],
    ["base", "1007", "Used for texturing parameters of type color"],
    ["base", "1008", "<tt>mono</tt>"],
    ["base", "1009", "Used for texturing parameters of type float"],
    ["base", "1010", "For bitmap textures, the <tt>mono</tt> value can be used to access the alpha channel of bitmaps."],
    ["base", "1011", "If a different coordinate space is used or the coordinate space is transformed then you will need to use the ancillary functions <tt>base::coordinate_source</tt>, <tt>base::coordinate_projection</tt> and <tt>base::coordinate_transformation</tt>. Internally, all coordinates for texturing are treated as 3D."],
    ["base", "1012", "To enable bump mapping, texturing functions with names ending with <tt>_bump_texture</tt> can be attached to the <tt>bump</tt> input parameter of distribution functions and the material geometry interface. A dedicated function <tt>base::tangent_space_normal_texture</tt> can be used to load tangent space normal map textures for normal mapping."],
    ["base", "1013", "For additional functionality, the output of texturing functions can be modified by using <tt>base::gradient3_recolor</tt> or combined with other textures and values through <tt>base::blend_color_layers</tt>, based on a number of blend operations."]
  ]],
  ["2.2 Ancillary functions", [
    ["base", "1014", "A number of ancillary functions complete module <tt>base.mdl</tt>."],
    ["base", "1015", "Functions <tt>base::coordinate_source</tt> and <tt>base::coordinate_projection</tt> allow advanced handling of 3D coordinates from various sources as well as procedural generation of coordinate systems through projection techniques. The enum <tt>base::projection_mode</tt> is used to specify the technique to be used:"],
    ["base", "1016", "Field name in <tt>base::projection_mode</tt>"],
    ["base", "1017", "Description"],
    ["base", "1018", "<tt>base::projection_cubic</tt>"],
    ["base", "1020", "The projection is formed by six planar projections. The geometry normal is modified to point away from the origin of the projection and then the major direction of the resulting normal is used to decide for each face which projection is to be used: Major direction"],
    ["base", "1021", "Projection plane"],
    ["base", "1022", "x"],
    ["base", "1023", "yz"],
    ["base", "1024", "-x"],
    ["base", "1025", "-yz"],
    ["base", "1026", "y"],
    ["base", "1027", "-xz"],
    ["base", "1028", "-y"],
    ["base", "1029", "xz"],
    ["base", "1030", "z"],
    ["base", "1031", "xy"],
    ["base", "1032", "-z"],
    ["base", "1033", "-xy"],
    ["base", "1034", "<tt>base::projection_tri_planar</tt>"],
    ["base", "1035", "Similar to projection_cubic, but in addition blends the texture smoothly on the edges."],
    ["base", "1036", "<tt>base::projection_spherical</tt>"],
    ["base", "1037", "Spherical projection around the z axis. The created texture space is scaled with the distance from the origin of the projection so that mapping happens according to the circumference of an object. For example, if the projection is applied to a sphere of radius 2, textures are repeated 4*PI times around the sphere."],
    ["base", "1038", "<tt>base::projection_spherical_normalized</tt>"],
    ["base", "1039", "Spherical projection around the z axis. u on the sphere is between -1 and 1, v is in the range -.5 to 0.5."],
    ["base", "1040", "<tt>base::projection_cylindrical</tt>"],
    ["base", "1041", "Projection targeted at objects close in shape to a capped cylinder aligned with the z axis. The geometry normal is modified to point away from the origin of the projection and the major direction of the resulting normal is z or -z, fitting planar projections are used. For all other directions, a cylindrical projection is used with z mapping to v. The mapping range of u is tied to the distance from the z axis of the projection."],
    ["base", "1042", "<tt>base::projection_cylindrical_normalized</tt>"],
    ["base", "1043", "Like <tt>base::projection_cylindrical</tt>, but u is normalized to always wrap twice onto the circumference of the cylinder (u is in the range -1 1)."],
    ["base", "1044", "<tt>base::projection_infinite_cylindrical</tt>"],
    ["base", "1045", "Cylindrical projection around the z axis. z is mapped to v and the mapping range of u is tied to the distance from the z axis of the projection."],
    ["base", "1046", "<tt>base::projection_infinite_cylindrical_normalised</tt>"],
    ["base", "1047", "Cylindrical projection around the z axis. z is mapped to v and u is normalized to always wrap twice onto the circumference of the cylinder (u is in the range -1 1)."],
    ["base", "1048", "<tt>base::projection_planar</tt>"],
    ["base", "1049", "Planar projection along the z axis. The plane of projection is xy."],
    ["base", "1050", "Function <tt>base::transform_coordinate</tt> allows 3D transformations of those coordinates and <tt>base::rotation_translation_scale</tt> provides one way to generate the necessary transformation matrix."],
    ["base", "1051", "MDL allows the simulation of dispersion effects. The functions <tt>base::abbe_number_ior</tt> and <tt>base::sellmeier_coefficients_ior</tt> allow the specification of the necessarily varying index of refraction used by the material."],
    ["base", "1052", "The new explicit tangential alignment of roughness values for glossy BSDF allows full control over anisotropic effects and the functions <tt>base::anisotropy_conversion</tt> in conjunction with <tt>base::gloss_to_rough</tt> and <tt>base::architectural_gloss_to_rough</tt> enable designers use the semantic for anisotropy they prefer while still retaining the alignment information."]
  ]],
  ["3 Language elements", [
    ["base", "1053", "Functions"],
    ["base", "1054", "Structs"],
    ["base", "1055", "Enums"],
    ["base", "1056", "<tt>abbe_number_ior</tt>"],
    ["base", "1057", "<tt>anisotropy_return</tt>"],
    ["base", "1058", "<tt>color_layer_mode</tt>"],
    ["base", "1059", "<tt>anisotropy_conversion</tt>"],
    ["base", "1060", "<tt>color_layer</tt>"],
    ["base", "1061", "<tt>gradient_interpolation_mode</tt>"],
    ["base", "1062", "<tt>architectural_gloss_to_rough</tt>"],
    ["base", "1063", "<tt>texture_coordinate_info</tt>"],
    ["base", "1064", "<tt>gradient_mode</tt>"],
    ["base", "1065", "<tt>blend_color_layers</tt>"],
    ["base", "1066", "<tt>texture_return</tt>"],
    ["base", "1067", "<tt>mono_mode</tt>"],
    ["base", "1068", "<tt>checker_bump_texture</tt>"],
    ["base", "1070", "<tt>projection_mode</tt>"],
    ["base", "1071", "<tt>checker_texture</tt>"],
    ["base", "1073", "<tt>texture_coordinate_system</tt>"],
    ["base", "1074", "<tt>coordinate_projection</tt>"],
    ["base", "1077", "<tt>coordinate_source</tt>"],
    ["base", "1080", "<tt>environment_spherical</tt>"],
    ["base", "1083", "<tt>file_bump_texture</tt>"],
    ["base", "1086", "<tt>file_texture</tt>"],
    ["base", "1089", "<tt>flake_noise_bump_texture</tt>"],
    ["base", "1092", "<tt>flake_noise_texture</tt>"],
    ["base", "1095", "<tt>flow_noise_bump_texture</tt>"],
    ["base", "1098", "<tt>flow_noise_texture</tt>"],
    ["base", "1101", "<tt>gloss_to_rough</tt>"],
    ["base", "1104", "<tt>gradient3_bump_texture</tt>"],
    ["base", "1107", "<tt>gradient3_recolor</tt>"],
    ["base", "1110", "<tt>gradient3_texture</tt>"],
    ["base", "1113", "<tt>perez_sun_and_sky</tt>"],
    ["base", "1116", "<tt>perlin_noise_bump_texture</tt>"],
    ["base", "1119", "<tt>perlin_noise_texture</tt>"],
    ["base", "1122", "<tt>rotation_translation_scale</tt>"],
    ["base", "1125", "<tt>sellmeier_coefficients_ior</tt>"],
    ["base", "1128", "<tt>sun_and_sky</tt>"],
    ["base", "1131", "<tt>tangent_space_normal_texture</tt>"],
    ["base", "1134", "<tt>tile_bump_texture</tt>"],
    ["base", "1137", "<tt>tile_texture</tt>"],
    ["base", "1140", "<tt>transform_coordinate</tt>"],
    ["base", "1143", "<tt>worley_noise_bump_texture</tt>"],
    ["base", "1146", "<tt>worley_noise_texture</tt>"]
  ]],
  ["4 Enums", [
    ["base", "1149", "<tt>projection_mode</tt><i>enum </i>"],
    ["base", "1150", "Methods for texture projection"],
    ["base", "1151", "Name"],
    ["base", "1152", "Description"],
    ["base", "1153", "<tt>projection_cubic</tt>"],
    ["base", "1154", "Projected space has a cube-shaped appearance"],
    ["base", "1155", "<tt>projection_spherical</tt>"],
    ["base", "1156", "Projected space forms a sphere around the projector"],
    ["base", "1157", "<tt>projection_cylindrical</tt>"],
    ["base", "1158", "Projected space forms a capped cylinder"],
    ["base", "1159", "<tt>projection_infinite_cylindrical</tt>"],
    ["base", "1160", "Projected space forms an infinite cylinder"],
    ["base", "1161", "<tt>projection_planar</tt>"],
    ["base", "1162", "Planar projection along the z axis of the projectors space"],
    ["base", "1163", "<tt>projection_spherical_normalized</tt>"],
    ["base", "1164", "Like <tt>projection_spherical</tt>, but u is normalized between -1 and 1 and v between -0.5 and 0.5"],
    ["base", "1165", "<tt>projection_cylindrical_normalized</tt>"],
    ["base", "1166", "Like <tt>projection_cylindrical</tt>, but u is normalized between -1 and 1 (if not on the cap)"],
    ["base", "1167", "<tt>projection_infinite_cylindrical_normalized</tt>"],
    ["base", "1168", "Like <tt>projection_cylindrical_infinite</tt>, but u is normalized between -1 and 1"],
    ["base", "1169", "<tt>projection_tri_planar</tt>"],
    ["base", "1170", "Like <tt>projection_cubic</tt>, but blends the texture smoothly on the edges"],
    ["base", "1171", "<tt>color_layer_mode</tt><i>enum </i>"],
    ["base", "1172", "Texture combination modes between two layers. the two layers are modified in the manner described by the modes, and the result is blended with the bottom layer based on a weighting factor."],
    ["base", "1173", "Name"],
    ["base", "1174", "Description"],
    ["base", "1175", "<tt>color_layer_blend</tt>"],
    ["base", "1176", "Top"],
    ["base", "1177", "<tt>color_layer_add</tt>"],
    ["base", "1178", "Top + bottom"],
    ["base", "1179", "<tt>color_layer_multiply</tt>"],
    ["base", "1180", "Top * bottom"],
    ["base", "1181", "<tt>color_layer_screen</tt>"],
    ["base", "1182", "1 - ((1 - top) * (1 - bottom))"],
    ["base", "1183", "<tt>color_layer_overlay</tt>"],
    ["base", "1184", "For each channel individually: if bottom < 0.5: top*bottom*2, else: 2*(top+bottom-top*bottom-0.5)"],
    ["base", "1185", "<tt>color_layer_brightness</tt>"],
    ["base", "1186", "Hue of the bottom layer combined with the intensity of the top"],
    ["base", "1187", "<tt>color_layer_color</tt>"],
    ["base", "1188", "Intensity of the bottom layer combined with the hue of the top"],
    ["base", "1189", "<tt>color_layer_exclusion</tt>"],
    ["base", "1190", "Bottom + top - bottom * top * 2"],
    ["base", "1191", "<tt>color_layer_average</tt>"],
    ["base", "1192", "Average of top and bottom layer"],
    ["base", "1193", "<tt>color_layer_lighten</tt>"],
    ["base", "1194", "Maximum of top and bottom layer"],
    ["base", "1195", "<tt>color_layer_darken</tt>"],
    ["base", "1196", "Minimum of top and bottom layer"],
    ["base", "1197", "<tt>color_layer_sub</tt>"],
    ["base", "1198", "Bottom + top - 1"],
    ["base", "1199", "<tt>color_layer_negation</tt>"],
    ["base", "1200", "1 - math::abs(1 - (bottom + top))"],
    ["base", "1201", "<tt>color_layer_difference</tt>"],
    ["base", "1202", "Absolute difference of top and bottom layer"],
    ["base", "1203", "<tt>color_layer_softlight</tt>"],
    ["base", "1204", "(top < 0.5) ? 2 * (top * bottom + bottom * bottom * (0.5 - top)) : 2 * (math::sqrt(bottom) * (top - 0.5) + bottom - top * bottom)"],
    ["base", "1205", "<tt>color_layer_colordodge</tt>"],
    ["base", "1206", "Bottom &#47; (1 - top)"],
    ["base", "1207", "<tt>color_layer_reflect</tt>"],
    ["base", "1208", "Bottom * bottom&#47;(1 - top)"],
    ["base", "1209", "<tt>color_layer_colorburn</tt>"],
    ["base", "1210", "1 - (1 - bottom)&#47;top"],
    ["base", "1211", "<tt>color_layer_phoenix</tt>"],
    ["base", "1212", "Minimum of both layers minus the maximum of both layers (plus 1.0)"],
    ["base", "1213", "<tt>color_layer_hardlight</tt>"],
    ["base", "1214", "For each channel individually: if top >0.5: top*bottom*2, else: 2*(top+bottom-top*bottom-0.5)"],
    ["base", "1215", "<tt>color_layer_pinlight</tt>"],
    ["base", "1217", "<tt>color_layer_hardmix</tt>"],
    ["base", "1218", "For each channel individually: (top+bottom < = 1) ? 0 : 1"],
    ["base", "1219", "<tt>color_layer_lineardodge</tt>"],
    ["base", "1220", "Top + bottom (clamped)"],
    ["base", "1221", "<tt>color_layer_linearburn</tt>"],
    ["base", "1222", "Bottom + top - 1 (clamped)"],
    ["base", "1223", "<tt>color_layer_spotlight</tt>"],
    ["base", "1224", "2 * top * bottom"],
    ["base", "1225", "<tt>color_layer_spotlightblend</tt>"],
    ["base", "1226", "Top * bottom + bottom"],
    ["base", "1227", "<tt>color_layer_hue</tt>"],
    ["base", "1228", "Uses hue from top layer, saturation and brightness from bottom"],
    ["base", "1229", "<tt>color_layer_saturation</tt>"],
    ["base", "1230", "Uses saturation from top layer, hue and brightness from bottom"],
    ["base", "1231", "<tt>texture_coordinate_system</tt><i>enum </i>"],
    ["base", "1232", "Coordinate system selection for textures"],
    ["base", "1233", "Name"],
    ["base", "1234", "Description"],
    ["base", "1235", "<tt>texture_coordinate_uvw</tt>"],
    ["base", "1236", "Texture space of surface"],
    ["base", "1237", "<tt>texture_coordinate_world</tt>"],
    ["base", "1238", "World coordinate space"],
    ["base", "1239", "<tt>texture_coordinate_object</tt>"],
    ["base", "1240", "Object coordinate space"],
    ["base", "1241", "<tt>mono_mode</tt><i>enum </i>"],
    ["base", "1242", "Modes for the creation of a gray-scale value from a color"],
    ["base", "1243", "Name"],
    ["base", "1244", "Description"],
    ["base", "1245", "<tt>mono_alpha</tt>"],
    ["base", "1246", "Alpha channel of the texture is used"],
    ["base", "1247", "<tt>mono_average</tt>"],
    ["base", "1248", "Average intensity of rgb is used"],
    ["base", "1249", "<tt>mono_luminance</tt>"],
    ["base", "1250", "Value is calculated using math::math::luminance()"],
    ["base", "1251", "<tt>mono_maximum</tt>"],
    ["base", "1252", "Maximum intensity of the texture is used"],
    ["base", "1253", "<tt>gradient_interpolation_mode</tt><i>enum </i>"],
    ["base", "1254", "Modes for interpolating between the different colors in a gradient texture"],
    ["base", "1255", "Name"],
    ["base", "1256", "Description"],
    ["base", "1257", "<tt>gradient_interpolation_linear</tt>"],
    ["base", "1258", "Linear interpolation"],
    ["base", "1259", "<tt>gradient_interpolation_off</tt>"],
    ["base", "1260", "No interpolation (\"solid\")"],
    ["base", "1261", "<tt>gradient_interpolation_ease_in</tt>"],
    ["base", "1262", "Ease-in"],
    ["base", "1263", "<tt>gradient_interpolation_ease_out</tt>"],
    ["base", "1264", "Ease-out"],
    ["base", "1265", "<tt>gradient_interpolation_ease_in_out</tt>"],
    ["base", "1266", "Ease-in-out"],
    ["base", "1267", "<tt>gradient_mode</tt><i>enum </i>"],
    ["base", "1268", "Modes for generating the gradient position based on input uv coordinates"],
    ["base", "1269", "Name"],
    ["base", "1270", "Description"],
    ["base", "1271", "<tt>gradient_linear</tt>"],
    ["base", "1272", "Linear"],
    ["base", "1273", "<tt>gradient_squared</tt>"],
    ["base", "1274", "Squared"],
    ["base", "1275", "<tt>gradient_box</tt>"],
    ["base", "1276", "Box"],
    ["base", "1277", "<tt>gradient_diagonal</tt>"],
    ["base", "1278", "Diagonal"],
    ["base", "1279", "<tt>gradient_90_degree</tt>"],
    ["base", "1280", "Asymmetric 90 degree"],
    ["base", "1281", "<tt>gradient_symmetric_90_degree</tt>"],
    ["base", "1282", "Symmetric 90 degree"],
    ["base", "1283", "<tt>gradient_radial</tt>"],
    ["base", "1284", "Radial"],
    ["base", "1285", "<tt>gradient_360_degree</tt>"],
    ["base", "1286", "360 degree"]
  ]],
  ["5 Structs", [
    ["base", "1287", "<tt>texture_coordinate_info</tt><i>struct </i>"],
    ["base", "1288", "The texture coordinate, <tt>tangent_u</tt> and <tt>tangent_v</tt> needed by bump mapping and anisotropy"],
    ["base", "1289", "Name"],
    ["base", "1290", "Type"],
    ["base", "1291", "Default"],
    ["base", "1292", "Description"],
    ["base", "1293", "<tt>position</tt>"],
    ["base", "1294", "<tt>float3</tt>"],
    ["base", "1295", "<tt>state::texture_coordinate(0)</tt>"],
    ["base", "1296", "Texture coordinate"],
    ["base", "1297", "<tt>tangent_u</tt>"],
    ["base", "1298", "<tt>float3</tt>"],
    ["base", "1299", "<tt>state::texture_tangent_u(0)</tt>"],
    ["base", "1300", "Tangent in <i>u </i> direction"],
    ["base", "1301", "<tt>tangent_v</tt>"],
    ["base", "1302", "<tt>float3</tt>"],
    ["base", "1303", "<tt>state::texture_tangent_v(0)</tt>"],
    ["base", "1304", "Tangent in <i>v </i> direction"],
    ["base", "1305", "<tt>color_layer</tt><i>struct </i>"],
    ["base", "1306", "Single texture layer for use in blending"],
    ["base", "1307", "Name"],
    ["base", "1308", "Type"],
    ["base", "1309", "Default"],
    ["base", "1310", "Description"],
    ["base", "1311", "<tt>layer_color</tt>"],
    ["base", "1312", "<tt>color</tt>"],
    ["base", "1313", "<tt>color(0)</tt>"],
    ["base", "1314", "The color to be combined with a layer \"below\" this layer"],
    ["base", "1315", "<tt>weight</tt>"],
    ["base", "1316", "<tt>float</tt>"],
    ["base", "1317", "<tt>1.0</tt>"],
    ["base", "1318", "Scale factor for blending this color with the color produced by the mode value (the \"lower layer\")"],
    ["base", "1319", "<tt>mode</tt>"],
    ["base", "1320", "<tt>uniform color_layer_mode</tt>"],
    ["base", "1321", "<tt>color_layer_blend</tt>"],
    ["base", "1322", "Method for combining this layer and the lower layer"],
    ["base", "1323", "<tt>texture_return</tt><i>struct </i>"],
    ["base", "1324", "Type of the return value from texturing functions"],
    ["base", "1325", "Name"],
    ["base", "1326", "Type"],
    ["base", "1327", "Default"],
    ["base", "1328", "Description"],
    ["base", "1329", "<tt>tint</tt>"],
    ["base", "1330", "<tt>color</tt>"],
    ["base", "1331", "<tt>color(0)</tt>"],
    ["base", "1332", "Return value suitable to for driving input parameters of type color"],
    ["base", "1333", "<tt>mono</tt>"],
    ["base", "1334", "<tt>float</tt>"],
    ["base", "1335", "<tt>0.0</tt>"],
    ["base", "1336", "Gray-scale return value suitable for driving input parameters of type float"],
    ["base", "1337", "<tt>anisotropy_return</tt><i>struct </i>"],
    ["base", "1338", "Type of the return value from functions driving roughness and anisotropy parameters of glossy bsdf"],
    ["base", "1339", "Name"],
    ["base", "1340", "Type"],
    ["base", "1341", "Default"],
    ["base", "1342", "Description"],
    ["base", "1343", "<tt>roughness_u</tt>"],
    ["base", "1344", "<tt>float</tt>"],
    ["base", "1345", "<tt>0.0</tt>"],
    ["base", "1346", "Roughness in <i>u </i> direction"],
    ["base", "1347", "<tt>roughness_v</tt>"],
    ["base", "1348", "<tt>float</tt>"],
    ["base", "1349", "<tt>0.0</tt>"],
    ["base", "1350", "Roughness in <i>v </i> direction"],
    ["base", "1351", "<tt>tangent_u</tt>"],
    ["base", "1352", "<tt>float3</tt>"],
    ["base", "1353", "<tt>state::texture_tangent_u(0)</tt>"],
    ["base", "1354", "Tangent in <i>u </i> direction"]
  ]],
  ["6 Functions", [
    ["base", "1355", "<tt>coordinate_projection</tt><i>returns </i><tt>texture_coordinate_info</tt>"],
    ["base", "1356", "Constructs a texturing coordinate system based on a variety of projection functions."],
    ["base", "1357", "Name"],
    ["base", "1358", "Type"],
    ["base", "1359", "Default"],
    ["base", "1360", "Range"],
    ["base", "1361", "Varying?"],
    ["base", "1362", "Description"],
    ["base", "1363", "<tt>coordinate_system</tt>"],
    ["base", "1364", "<tt>texture_coordinate_system</tt>"],
    ["base", "1365", "<tt>texture_coordinate_object</tt>"],
    ["base", "1367", "no"],
    ["base", "1368", "The projection can be done based on world, object or any <tt>uvw</tt> space."],
    ["base", "1369", "<tt>texture_space</tt>"],
    ["base", "1370", "<tt>int</tt>"],
    ["base", "1371", "<tt>0</tt>"],
    ["base", "1372", "0->255"],
    ["base", "1373", "no"],
    ["base", "1374", "If <tt>texture_coordinate_uvw</tt>, index into the appropriate one"],
    ["base", "1375", "<tt>projection_type</tt>"],
    ["base", "1376", "<tt>projection_mode</tt>"],
    ["base", "1377", "<tt>projection_planar</tt>"],
    ["base", "1379", "no"],
    ["base", "1380", "Projection method to be used to generate the coordinates"],
    ["base", "1381", "<tt>projection_transform</tt>"],
    ["base", "1382", "<tt>float4x4</tt>"],
    ["base", "1383", "<tt>float4x4(1.0)</tt>"],
    ["base", "1385", "no"],
    ["base", "1386", "Transformation of the projector in world space"],
    ["base", "1387", "<tt>coordinate_source</tt><i>returns </i><tt>texture_coordinate_info</tt>"],
    ["base", "1388", "Access to world coordinates, object coordinates or specifically defined texture spaces"],
    ["base", "1389", "Name"],
    ["base", "1390", "Type"],
    ["base", "1391", "Default"],
    ["base", "1392", "Range"],
    ["base", "1393", "Varying?"],
    ["base", "1394", "Description"],
    ["base", "1395", "<tt>coordinate_system</tt>"],
    ["base", "1396", "<tt>texture_coordinate_system</tt>"],
    ["base", "1397", "<tt>texture_coordinate_uvw</tt>"],
    ["base", "1399", "no"],
    ["base", "1400", "The function can source coordinates in <tt>uvw</tt>, world or object space"],
    ["base", "1401", "<tt>texture_space</tt>"],
    ["base", "1402", "<tt>int</tt>"],
    ["base", "1403", "<tt>0</tt>"],
    ["base", "1404", "0->255"],
    ["base", "1405", "no"],
    ["base", "1406", "If <tt>texture_coordinate_uvw</tt>, index into the appropriate one"],
    ["base", "1407", "<tt>transform_coordinate</tt><i>returns </i><tt>texture_coordinate_info</tt>"],
    ["base", "1408", "Transform a texture coordinate by a matrix"],
    ["base", "1409", "Name"],
    ["base", "1410", "Type"],
    ["base", "1411", "Default"],
    ["base", "1412", "Varying?"],
    ["base", "1413", "Description"],
    ["base", "1414", "<tt>transform</tt>"],
    ["base", "1415", "<tt>float4x4</tt>"],
    ["base", "1417", "no"],
    ["base", "1418", "A transformation to be applied to the source coordinates. <tt>rotation_translation_scale()</tt> is a suggested means to compute the transformation matrix"],
    ["base", "1419", "<tt>coordinate</tt>"],
    ["base", "1420", "<tt>texture_coordinate_info</tt>"],
    ["base", "1421", "<tt>texture_coordinate_info()</tt>"],
    ["base", "1422", "yes"],
    ["base", "1423", "Coordinate, typically sourced from <tt>coordinate_source</tt> or <tt>coordinate_projection</tt>"],
    ["base", "1424", "<tt>rotation_translation_scale</tt><i>returns </i><tt>uniform float4x4</tt>"],
    ["base", "1425", "Construct transformation matrix from euler rotation, translation and scale"],
    ["base", "1426", "Name"],
    ["base", "1427", "Type"],
    ["base", "1428", "Default"],
    ["base", "1429", "Varying?"],
    ["base", "1430", "Description"],
    ["base", "1431", "<tt>rotation</tt>"],
    ["base", "1432", "<tt>float3</tt>"],
    ["base", "1433", "<tt>float3(0.0)</tt>"],
    ["base", "1434", "no"],
    ["base", "1435", "Rotation applied to every uvw coordinate"],
    ["base", "1436", "<tt>translation</tt>"],
    ["base", "1437", "<tt>float3</tt>"],
    ["base", "1438", "<tt>float3(0.0)</tt>"],
    ["base", "1439", "no"],
    ["base", "1440", "Offset applied to every uvw coordinate"],
    ["base", "1441", "<tt>scaling</tt>"],
    ["base", "1442", "<tt>float3</tt>"],
    ["base", "1443", "<tt>float3(1.0)</tt>"],
    ["base", "1444", "no"],
    ["base", "1445", "Scale applied to every uvw coordinate"],
    ["base", "1446", "<tt>file_texture</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "1447", "General texturing function for 2d bitmap texture stored in a file"],
    ["base", "1448", "Name"],
    ["base", "1449", "Type"],
    ["base", "1450", "Default"],
    ["base", "1451", "Varying?"],
    ["base", "1452", "Description"],
    ["base", "1453", "<tt>texture</tt>"],
    ["base", "1454", "<tt>texture_2d</tt>"],
    ["base", "1456", "no"],
    ["base", "1457", "The input texture"],
    ["base", "1458", "<tt>color_offset</tt>"],
    ["base", "1459", "<tt>color</tt>"],
    ["base", "1460", "<tt>color(0.0)</tt>"],
    ["base", "1461", "yes"],
    ["base", "1462", "Fixed offset value added to all texture values"],
    ["base", "1463", "<tt>color_scale</tt>"],
    ["base", "1464", "<tt>color</tt>"],
    ["base", "1465", "<tt>color(1.0)</tt>"],
    ["base", "1466", "yes"],
    ["base", "1467", "Fixed scaling factor applied to all texture values"],
    ["base", "1468", "<tt>mono_source</tt>"],
    ["base", "1469", "<tt>mono_mode</tt>"],
    ["base", "1470", "<tt>mono_alpha</tt>"],
    ["base", "1471", "no"],
    ["base", "1472", "Defines how <tt>mono_result</tt> is computed"],
    ["base", "1473", "<tt>uvw</tt>"],
    ["base", "1474", "<tt>texture_coordinate_info</tt>"],
    ["base", "1475", "<tt>texture_coordinate_info()</tt>"],
    ["base", "1476", "yes"],
    ["base", "1477", "Custom value for texture coordinate"],
    ["base", "1478", "<tt>crop_u</tt>"],
    ["base", "1479", "<tt>float2</tt>"],
    ["base", "1480", "<tt>float2(0.0, 1.0)</tt>"],
    ["base", "1481", "no"],
    ["base", "1482", "Restricts the texture access to sub-domain of the texture in the <i>u </i> direction"],
    ["base", "1483", "<tt>crop_v</tt>"],
    ["base", "1484", "<tt>float2</tt>"],
    ["base", "1485", "<tt>float2(0.0, 1.0)</tt>"],
    ["base", "1486", "no"],
    ["base", "1487", "Restricts the texture access to sub-domain of the texture in the <i>v </i> direction"],
    ["base", "1488", "<tt>wrap_u</tt>"],
    ["base", "1489", "<tt>tex::wrap_mode</tt>"],
    ["base", "1490", "<tt>tex::wrap_repeat</tt>"],
    ["base", "1491", "no"],
    ["base", "1492", "Wrapping mode in the <i>u </i> direction"],
    ["base", "1493", "<tt>wrap_v</tt>"],
    ["base", "1494", "<tt>tex::wrap_mode</tt>"],
    ["base", "1495", "<tt>tex::wrap_repeat</tt>"],
    ["base", "1496", "no"],
    ["base", "1497", "Wrapping mode in the <i>v </i> direction"],
    ["base", "1498", "<tt>clip</tt>"],
    ["base", "1499", "<tt>bool</tt>"],
    ["base", "1500", "<tt>false</tt>"],
    ["base", "1501", "no"],
    ["base", "1502", "Deprecated, use <tt>wrap_mode</tt> =tex:: <tt>wrap_clip</tt>. defines <tt>wrap_clamp</tt> behavior. if true, a lookup outside [0,1] results in black&#47;transparent"],
    ["base", "1503", "<tt>architectural_gloss_to_rough</tt><i>returns </i><tt>float</tt>"],
    ["base", "1504", "Convert glossiness parameter to roughness parameter, semantics according to the iray v2 arch+design implementation"],
    ["base", "1505", "Name"],
    ["base", "1506", "Type"],
    ["base", "1507", "Default"],
    ["base", "1508", "Range"],
    ["base", "1509", "Varying?"],
    ["base", "1510", "Description"],
    ["base", "1511", "<tt>glossiness</tt>"],
    ["base", "1512", "<tt>float</tt>"],
    ["base", "1514", "0.0->1.0"],
    ["base", "1515", "yes"],
    ["base", "1516", "Glossiness according to mia material semantic"],
    ["base", "1517", "<tt>gloss_to_rough</tt><i>returns </i><tt>float</tt>"],
    ["base", "1518", "Convert glossiness parameter to roughness parameter through simple inversion"],
    ["base", "1519", "Name"],
    ["base", "1520", "Type"],
    ["base", "1521", "Default"],
    ["base", "1522", "Range"],
    ["base", "1523", "Varying?"],
    ["base", "1524", "Description"],
    ["base", "1525", "<tt>glossiness</tt>"],
    ["base", "1526", "<tt>float</tt>"],
    ["base", "1528", "0.0->1.0"],
    ["base", "1529", "yes"],
    ["base", "1530", "Inverse of roughness"],
    ["base", "1531", "<tt>abbe_number_ior</tt><i>returns </i><tt>color</tt>"],
    ["base", "1532", "Calculate spectral index of refraction"],
    ["base", "1533", "Name"],
    ["base", "1534", "Type"],
    ["base", "1535", "Default"],
    ["base", "1536", "Varying?"],
    ["base", "1537", "Description"],
    ["base", "1538", "<tt>ior</tt>"],
    ["base", "1539", "<tt>float</tt>"],
    ["base", "1540", "<tt>1.5</tt>"],
    ["base", "1541", "no"],
    ["base", "1542", "Index of refraction"],
    ["base", "1543", "<tt>abbe_number</tt>"],
    ["base", "1544", "<tt>float</tt>"],
    ["base", "1545", "<tt>0.0</tt>"],
    ["base", "1546", "no"],
    ["base", "1547", "Dispersion in relation to index of refraction"],
    ["base", "1548", "<tt>sellmeier_coefficients_ior</tt><i>returns </i><tt>color</tt>"],
    ["base", "1549", "Calculate spectral index of refraction using sellmeier coefficients"],
    ["base", "1550", "Name"],
    ["base", "1551", "Type"],
    ["base", "1552", "Default"],
    ["base", "1553", "Varying?"],
    ["base", "1554", "Description"],
    ["base", "1555", "<tt>sellmeier_B</tt>"],
    ["base", "1556", "<tt>float3</tt>"],
    ["base", "1557", "<tt>float3(1.04, 0.23, 1.01)</tt>"],
    ["base", "1558", "no"],
    ["base", "1559", "Sellmeier coefficient b"],
    ["base", "1560", "<tt>sellmeier_C</tt>"],
    ["base", "1561", "<tt>float3</tt>"],
    ["base", "1562", "<tt>float3(0.006, 0.200, 103.56)</tt>"],
    ["base", "1563", "no"],
    ["base", "1564", "Sellmeier coefficient c (in <tt>um__power__2)</tt>"],
    ["base", "1565", "<tt>environment_spherical</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "1566", "Environment function implementing a spherical environment"],
    ["base", "1567", "Name"],
    ["base", "1568", "Type"],
    ["base", "1569", "Default"],
    ["base", "1570", "Varying?"],
    ["base", "1571", "Description"],
    ["base", "1572", "<tt>texture</tt>"],
    ["base", "1573", "<tt>texture_2d</tt>"],
    ["base", "1575", "no"],
    ["base", "1576", "Spherical environment"],
    ["base", "1577", "<tt>sun_and_sky</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "1578", "Sun and sky model environment. (For documentation of the parameters, please see the official documentation of the matching mental ray shader.)"],
    ["base", "1579", "Name"],
    ["base", "1580", "Type"],
    ["base", "1581", "Default"],
    ["base", "1582", "Varying?"],
    ["base", "1583", "Description"],
    ["base", "1584", "<tt>on</tt>"],
    ["base", "1585", "<tt>bool</tt>"],
    ["base", "1586", "<tt>true</tt>"],
    ["base", "1587", "no"],
    ["base", "1589", "<tt>multiplier</tt>"],
    ["base", "1590", "<tt>float</tt>"],
    ["base", "1591", "<tt>0.025</tt>"],
    ["base", "1592", "yes"],
    ["base", "1594", "<tt>rgb_unit_conversion</tt>"],
    ["base", "1595", "<tt>color</tt>"],
    ["base", "1596", "<tt>color(0.000666667)</tt>"],
    ["base", "1597", "no"],
    ["base", "1599", "<tt>haze</tt>"],
    ["base", "1600", "<tt>float</tt>"],
    ["base", "1601", "<tt>0.5</tt>"],
    ["base", "1602", "yes"],
    ["base", "1604", "<tt>redblueshift</tt>"],
    ["base", "1605", "<tt>float</tt>"],
    ["base", "1606", "<tt>0.0</tt>"],
    ["base", "1607", "yes"],
    ["base", "1609", "<tt>saturation</tt>"],
    ["base", "1610", "<tt>float</tt>"],
    ["base", "1611", "<tt>0.5</tt>"],
    ["base", "1612", "no"],
    ["base", "1614", "<tt>horizon_height</tt>"],
    ["base", "1615", "<tt>float</tt>"],
    ["base", "1616", "<tt>0.001</tt>"],
    ["base", "1617", "yes"],
    ["base", "1619", "<tt>horizon_blur</tt>"],
    ["base", "1620", "<tt>float</tt>"],
    ["base", "1621", "<tt>0.1</tt>"],
    ["base", "1622", "yes"],
    ["base", "1624", "<tt>ground_color</tt>"],
    ["base", "1625", "<tt>color</tt>"],
    ["base", "1626", "<tt>color(0.4, 0.4, 0.4)</tt>"],
    ["base", "1627", "yes"],
    ["base", "1629", "<tt>night_color</tt>"],
    ["base", "1630", "<tt>color</tt>"],
    ["base", "1631", "<tt>color(0.0, 0.0, 0.0)</tt>"],
    ["base", "1632", "yes"],
    ["base", "1634", "<tt>sun_direction</tt>"],
    ["base", "1635", "<tt>float3</tt>"],
    ["base", "1636", "<tt>float3(0.0, 0.229271, 0.418882)</tt>"],
    ["base", "1637", "no"],
    ["base", "1639", "<tt>sun_disk_intensity</tt>"],
    ["base", "1640", "<tt>float</tt>"],
    ["base", "1641", "<tt>0.01</tt>"],
    ["base", "1642", "no"],
    ["base", "1644", "<tt>sun_disk_scale</tt>"],
    ["base", "1645", "<tt>float</tt>"],
    ["base", "1646", "<tt>0.5</tt>"],
    ["base", "1647", "no"],
    ["base", "1649", "<tt>sun_glow_intensity</tt>"],
    ["base", "1650", "<tt>float</tt>"],
    ["base", "1651", "<tt>1.0</tt>"],
    ["base", "1652", "no"],
    ["base", "1654", "<tt>y_is_up</tt>"],
    ["base", "1655", "<tt>bool</tt>"],
    ["base", "1656", "<tt>true</tt>"],
    ["base", "1657", "no"],
    ["base", "1659", "<tt>flags</tt>"],
    ["base", "1660", "<tt>int</tt>"],
    ["base", "1661", "<tt>0</tt>"],
    ["base", "1662", "no"],
    ["base", "1664", "<tt>physically_scaled_sun</tt>"],
    ["base", "1665", "<tt>bool</tt>"],
    ["base", "1666", "<tt>true</tt>"],
    ["base", "1667", "no"],
    ["base", "1669", "<tt>perez_sun_and_sky</tt><i>returns </i><tt>color</tt>"],
    ["base", "1670", "Perez all weather sun and sky model."],
    ["base", "1671", "Name"],
    ["base", "1672", "Type"],
    ["base", "1673", "Default"],
    ["base", "1674", "Varying?"],
    ["base", "1675", "Description"],
    ["base", "1676", "<tt>direct_normal_irradiance</tt>"],
    ["base", "1677", "<tt>float</tt>"],
    ["base", "1678", "<tt>500.0</tt>"],
    ["base", "1679", "no"],
    ["base", "1680", "Direct sun irradiance in w &#47; <tt>m__power__2</tt>"],
    ["base", "1681", "<tt>diffuse_horizontal_irradiance</tt>"],
    ["base", "1682", "<tt>float</tt>"],
    ["base", "1683", "<tt>50.0</tt>"],
    ["base", "1684", "no"],
    ["base", "1685", "Diffuse horizontal sky irradiance in w &#47; <tt>m__power__2</tt> (excluding sun)"],
    ["base", "1686", "<tt>sun_direction</tt>"],
    ["base", "1687", "<tt>float3</tt>"],
    ["base", "1688", "<tt>float3(0.0, 0.229271, 0.418882)</tt>"],
    ["base", "1689", "no"],
    ["base", "1690", "Sun direction"],
    ["base", "1691", "<tt>ground_color</tt>"],
    ["base", "1692", "<tt>color</tt>"],
    ["base", "1693", "<tt>color(0.2, 0.2, 0.2)</tt>"],
    ["base", "1694", "yes"],
    ["base", "1695", "Ground reflectivity"],
    ["base", "1696", "<tt>horizon_blur</tt>"],
    ["base", "1697", "<tt>float</tt>"],
    ["base", "1698", "<tt>0.1</tt>"],
    ["base", "1699", "no"],
    ["base", "1700", "Blur between ground and sky at the horizon"],
    ["base", "1701", "<tt>y_is_up</tt>"],
    ["base", "1702", "<tt>bool</tt>"],
    ["base", "1703", "<tt>true</tt>"],
    ["base", "1704", "no"],
    ["base", "1705", "Sun direction is y-up coordinates"],
    ["base", "1706", "<tt>julian_date</tt>"],
    ["base", "1707", "<tt>float</tt>"],
    ["base", "1708", "<tt>180.0</tt>"],
    ["base", "1709", "no"],
    ["base", "1710", "Day in year"],
    ["base", "1711", "<tt>dew_point</tt>"],
    ["base", "1712", "<tt>float</tt>"],
    ["base", "1713", "<tt>11.0</tt>"],
    ["base", "1714", "no"],
    ["base", "1715", "Dew point in degree Celsius"],
    ["base", "1716", "<tt>haze</tt>"],
    ["base", "1717", "<tt>float</tt>"],
    ["base", "1718", "<tt>0.5</tt>"],
    ["base", "1719", "no"],
    ["base", "1720", "Haze value to compute chromaticity of the sky (in analogy to base:: <tt>sun_and_sky)</tt>"],
    ["base", "1721", "<tt>file_bump_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "1722", "Computes a normal based on a heightfield-style bump texture"],
    ["base", "1723", "Name"],
    ["base", "1724", "Type"],
    ["base", "1725", "Default"],
    ["base", "1726", "Varying?"],
    ["base", "1727", "Description"],
    ["base", "1728", "<tt>texture</tt>"],
    ["base", "1729", "<tt>texture_2d</tt>"],
    ["base", "1731", "no"],
    ["base", "1732", "The input texture"],
    ["base", "1733", "<tt>factor</tt>"],
    ["base", "1734", "<tt>float</tt>"],
    ["base", "1735", "<tt>1.0f</tt>"],
    ["base", "1736", "no"],
    ["base", "1737", "Determines the degree of bumpiness"],
    ["base", "1738", "<tt>bump_source</tt>"],
    ["base", "1739", "<tt>mono_mode</tt>"],
    ["base", "1740", "<tt>mono_average</tt>"],
    ["base", "1741", "no"],
    ["base", "1742", "Defines what value to use for computing the slope of the bump"],
    ["base", "1743", "<tt>uvw</tt>"],
    ["base", "1744", "<tt>texture_coordinate_info</tt>"],
    ["base", "1745", "<tt>texture_coordinate_info()</tt>"],
    ["base", "1746", "yes"],
    ["base", "1747", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "1748", "<tt>crop_u</tt>"],
    ["base", "1749", "<tt>float2</tt>"],
    ["base", "1750", "<tt>float2(0.0, 1.0)</tt>"],
    ["base", "1751", "no"],
    ["base", "1752", "Restricts the texture access to sub-domain of the texture in the <i>u </i> direction"],
    ["base", "1753", "<tt>crop_v</tt>"],
    ["base", "1754", "<tt>float2</tt>"],
    ["base", "1755", "<tt>float2(0.0, 1.0)</tt>"],
    ["base", "1756", "no"],
    ["base", "1757", "Restricts the texture access to sub-domain of the texture in the <i>v </i> direction"],
    ["base", "1758", "<tt>wrap_u</tt>"],
    ["base", "1759", "<tt>tex::wrap_mode</tt>"],
    ["base", "1760", "<tt>tex::wrap_repeat</tt>"],
    ["base", "1761", "no"],
    ["base", "1762", "Wrapping mode in the <i>u </i> direction"],
    ["base", "1763", "<tt>wrap_v</tt>"],
    ["base", "1764", "<tt>tex::wrap_mode</tt>"],
    ["base", "1765", "<tt>tex::wrap_repeat</tt>"],
    ["base", "1766", "no"],
    ["base", "1767", "Wrapping mode in the <i>v </i> direction"],
    ["base", "1768", "<tt>normal</tt>"],
    ["base", "1769", "<tt>float3</tt>"],
    ["base", "1770", "<tt>state::normal()</tt>"],
    ["base", "1771", "yes"],
    ["base", "1772", "Base normal for the bump mapping. note, apart from the default, only state:: <tt>rounded_corners</tt> is supported here and only in the material.geometry.normal slot."],
    ["base", "1773", "<tt>clip</tt>"],
    ["base", "1774", "<tt>bool</tt>"],
    ["base", "1775", "<tt>false</tt>"],
    ["base", "1776", "no"],
    ["base", "1777", "Deprecated, <tt>usewrap_mode</tt> =tex:: <tt>wrap_clip</tt>. defines <tt>wrap_clamp</tt> behavior. if true, lookup outside [0,1] results in no bump"],
    ["base", "1778", "<tt>tangent_space_normal_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "1779", "Interprets the color values of a bitmap as a vector in tangent space"],
    ["base", "1780", "Name"],
    ["base", "1781", "Type"],
    ["base", "1782", "Default"],
    ["base", "1783", "Varying?"],
    ["base", "1784", "Description"],
    ["base", "1785", "<tt>texture</tt>"],
    ["base", "1786", "<tt>texture_2d</tt>"],
    ["base", "1788", "no"],
    ["base", "1789", "The input texture"],
    ["base", "1790", "<tt>factor</tt>"],
    ["base", "1791", "<tt>float</tt>"],
    ["base", "1792", "<tt>1.0f</tt>"],
    ["base", "1793", "no"],
    ["base", "1794", "Determines the degree of bumpiness"],
    ["base", "1795", "<tt>flip_tangent_u</tt>"],
    ["base", "1796", "<tt>bool</tt>"],
    ["base", "1797", "<tt>false</tt>"],
    ["base", "1798", "no"],
    ["base", "1799", "Can be used to fix mismatches between the object's tangent space and the normal map's tangent space"],
    ["base", "1800", "<tt>flip_tangent_v</tt>"],
    ["base", "1801", "<tt>bool</tt>"],
    ["base", "1802", "<tt>false</tt>"],
    ["base", "1803", "no"],
    ["base", "1804", "Can be used to fix mismatches between the object's tangent space and the normal map's tangent space"],
    ["base", "1805", "<tt>uvw</tt>"],
    ["base", "1806", "<tt>texture_coordinate_info</tt>"],
    ["base", "1807", "<tt>texture_coordinate_info()</tt>"],
    ["base", "1808", "yes"],
    ["base", "1809", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "1810", "<tt>crop_u</tt>"],
    ["base", "1811", "<tt>float2</tt>"],
    ["base", "1812", "<tt>float2(0.0, 1.0)</tt>"],
    ["base", "1813", "no"],
    ["base", "1814", "Restricts the texture access to sub-domain of the texture in the <i>u </i> direction"],
    ["base", "1815", "<tt>crop_v</tt>"],
    ["base", "1816", "<tt>float2</tt>"],
    ["base", "1817", "<tt>float2(0.0, 1.0)</tt>"],
    ["base", "1818", "no"],
    ["base", "1819", "Restricts the texture access to sub-domain of the texture in the <i>v </i> direction"],
    ["base", "1820", "<tt>wrap_u</tt>"],
    ["base", "1821", "<tt>tex::wrap_mode</tt>"],
    ["base", "1822", "<tt>tex::wrap_repeat</tt>"],
    ["base", "1823", "no"],
    ["base", "1824", "Wrapping mode in the <i>u </i> direction"],
    ["base", "1825", "<tt>wrap_v</tt>"],
    ["base", "1826", "<tt>tex::wrap_mode</tt>"],
    ["base", "1827", "<tt>tex::wrap_repeat</tt>"],
    ["base", "1828", "no"],
    ["base", "1829", "Wrapping mode in the <i>v </i> direction"],
    ["base", "1830", "<tt>clip</tt>"],
    ["base", "1831", "<tt>bool</tt>"],
    ["base", "1832", "<tt>false</tt>"],
    ["base", "1833", "no"],
    ["base", "1834", "Deprecated, <tt>usewrap_mode</tt> =tex:: <tt>wrap_clip</tt>. defines <tt>wrap_clamp</tt> behavior. if true, lookup outside [0,1] results in no bump"],
    ["base", "1835", "<tt>scale</tt>"],
    ["base", "1836", "<tt>float</tt>"],
    ["base", "1837", "<tt>1.0</tt>"],
    ["base", "1838", "no"],
    ["base", "1839", "Scales the value red from the texture file. can be used to adapt to different normal map formats"],
    ["base", "1840", "<tt>offset</tt>"],
    ["base", "1841", "<tt>float</tt>"],
    ["base", "1842", "<tt>0.0</tt>"],
    ["base", "1843", "no"],
    ["base", "1844", "Offset applied to the value red from the texture file. can be used to adapt to different normal map formats"],
    ["base", "1845", "<tt>blend_color_layers</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "1846", "Texture layering functionality similar to the functionality known from painting programs"],
    ["base", "1847", "Name"],
    ["base", "1848", "Type"],
    ["base", "1849", "Default"],
    ["base", "1850", "Varying?"],
    ["base", "1851", "Description"],
    ["base", "1852", "<tt>layers</tt>"],
    ["base", "1853", "color_layer[ ]"],
    ["base", "1855", "yes"],
    ["base", "1856", "Array of structs describing the layers to blend"],
    ["base", "1857", "<tt>base</tt>"],
    ["base", "1858", "<tt>color</tt>"],
    ["base", "1859", "<tt>color(0.0)</tt>"],
    ["base", "1860", "yes"],
    ["base", "1861", "Color of initial layer"],
    ["base", "1862", "<tt>mono_source</tt>"],
    ["base", "1863", "<tt>mono_mode</tt>"],
    ["base", "1864", "<tt>mono_average</tt>"],
    ["base", "1865", "no"],
    ["base", "1866", "Defines how <tt>mono_result</tt> is computed"],
    ["base", "1867", "<tt>gradient3_texture</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "1868", "Gradient calculated from three colors at three positions"],
    ["base", "1869", "Name"],
    ["base", "1870", "Type"],
    ["base", "1871", "Default"],
    ["base", "1872", "Varying?"],
    ["base", "1873", "Description"],
    ["base", "1874", "<tt>mode</tt>"],
    ["base", "1875", "<tt>gradient_mode</tt>"],
    ["base", "1876", "<tt>gradient_linear</tt>"],
    ["base", "1877", "no"],
    ["base", "1878", "Mode of gradient calculation, describes shape of the gradient"],
    ["base", "1879", "<tt>gradient_positions</tt>"],
    ["base", "1880", "<tt>float[3]</tt>"],
    ["base", "1881", "<tt>float[](0.0, 0.5, 1.0 )</tt>"],
    ["base", "1882", "yes"],
    ["base", "1883", "Position of the gradient colors"],
    ["base", "1884", "<tt>gradient_colors</tt>"],
    ["base", "1885", "<tt>color[3]</tt>"],
    ["base", "1886", "color[]( color(0.0), color(0.5), color(1.0) )"],
    ["base", "1887", "yes"],
    ["base", "1888", "Colors at the positions"],
    ["base", "1889", "<tt>interpolation_modes</tt>"],
    ["base", "1890", "<tt>gradient_interpolation_mode[3]</tt>"],
    ["base", "1891", "gradient_interpolation_mode[]( gradient_interpolation_linear, gradient_interpolation_linear, gradient_interpolation_linear )"],
    ["base", "1892", "yes"],
    ["base", "1893", "Interpolation mode between gradient colors"],
    ["base", "1894", "<tt>uvw</tt>"],
    ["base", "1895", "<tt>texture_coordinate_info</tt>"],
    ["base", "1896", "<tt>texture_coordinate_info()</tt>"],
    ["base", "1897", "yes"],
    ["base", "1898", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "1899", "<tt>distortion</tt>"],
    ["base", "1900", "<tt>float</tt>"],
    ["base", "1901", "<tt>0.0</tt>"],
    ["base", "1902", "yes"],
    ["base", "1903", "Distortion value to be added to the position inside the gradient"],
    ["base", "1904", "<tt>gradient3_bump_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "1905", "Gradient for bump mapping calculated from three colors at three positions"],
    ["base", "1906", "Name"],
    ["base", "1907", "Type"],
    ["base", "1908", "Default"],
    ["base", "1909", "Varying?"],
    ["base", "1910", "Description"],
    ["base", "1911", "<tt>mode</tt>"],
    ["base", "1912", "<tt>gradient_mode</tt>"],
    ["base", "1913", "<tt>gradient_linear</tt>"],
    ["base", "1914", "no"],
    ["base", "1915", "Mode of gradient calculation, describes shape of the gradient"],
    ["base", "1916", "<tt>gradient_positions</tt>"],
    ["base", "1917", "<tt>float[3]</tt>"],
    ["base", "1918", "<tt>float[](0.0, 0.5, 1.0 )</tt>"],
    ["base", "1919", "yes"],
    ["base", "1920", "Position of the gradient colors"],
    ["base", "1921", "<tt>gradient_colors</tt>"],
    ["base", "1922", "<tt>color[3]</tt>"],
    ["base", "1923", "color[]( color(0.0), color(0.5), color(1.0) )"],
    ["base", "1924", "yes"],
    ["base", "1925", "Colors at the positions"],
    ["base", "1926", "<tt>interpolation_modes</tt>"],
    ["base", "1927", "<tt>gradient_interpolation_mode[3]</tt>"],
    ["base", "1928", "gradient_interpolation_mode[]( gradient_interpolation_linear, gradient_interpolation_linear, gradient_interpolation_linear )"],
    ["base", "1929", "yes"],
    ["base", "1930", "Interpolation mode between gradient colors"],
    ["base", "1931", "<tt>uvw</tt>"],
    ["base", "1932", "<tt>texture_coordinate_info</tt>"],
    ["base", "1933", "<tt>texture_coordinate_info()</tt>"],
    ["base", "1934", "yes"],
    ["base", "1935", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "1936", "<tt>distortion</tt>"],
    ["base", "1937", "<tt>float</tt>"],
    ["base", "1938", "<tt>0.0</tt>"],
    ["base", "1939", "yes"],
    ["base", "1940", "Distortion value to be added to the position inside the gradient"],
    ["base", "1941", "<tt>scale</tt>"],
    ["base", "1942", "<tt>float</tt>"],
    ["base", "1943", "<tt>1.0</tt>"],
    ["base", "1944", "yes"],
    ["base", "1945", "Strength of the bump mapping effect"],
    ["base", "1946", "<tt>normal</tt>"],
    ["base", "1947", "<tt>float3</tt>"],
    ["base", "1948", "<tt>state::normal()</tt>"],
    ["base", "1949", "yes"],
    ["base", "1950", "Base normal for the bump mapping. note, apart from the default, only state:: <tt>rounded_corners</tt> is supported here and only in the material.geometry.normal slot."],
    ["base", "1951", "<tt>gradient3_recolor</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "1952", "Function mapping an arbitrary float value into a gradient. can be used to re-color textures"],
    ["base", "1953", "Name"],
    ["base", "1954", "Type"],
    ["base", "1955", "Default"],
    ["base", "1956", "Varying?"],
    ["base", "1957", "Description"],
    ["base", "1958", "<tt>gradient_positions</tt>"],
    ["base", "1959", "<tt>float[3]</tt>"],
    ["base", "1960", "<tt>float[](0.0, 0.5, 1.0 )</tt>"],
    ["base", "1961", "yes"],
    ["base", "1962", "Position of the gradient colors"],
    ["base", "1963", "<tt>gradient_colors</tt>"],
    ["base", "1964", "<tt>color[3]</tt>"],
    ["base", "1965", "color[]( color(0.0), color(0.5), color(1.0) )"],
    ["base", "1966", "yes"],
    ["base", "1967", "Colors at the positions"],
    ["base", "1968", "<tt>interpolation_modes</tt>"],
    ["base", "1969", "<tt>gradient_interpolation_mode[3]</tt>"],
    ["base", "1970", "gradient_interpolation_mode[]( gradient_interpolation_linear, gradient_interpolation_linear, gradient_interpolation_linear )"],
    ["base", "1971", "yes"],
    ["base", "1972", "Mode of gradient calculations"],
    ["base", "1973", "<tt>mono_source</tt>"],
    ["base", "1974", "<tt>mono_mode</tt>"],
    ["base", "1975", "<tt>mono_alpha</tt>"],
    ["base", "1976", "no"],
    ["base", "1977", "Deprecated, has no effect in gradient3 recolor"],
    ["base", "1978", "<tt>distortion</tt>"],
    ["base", "1979", "<tt>float</tt>"],
    ["base", "1980", "<tt>0.0</tt>"],
    ["base", "1981", "yes"],
    ["base", "1982", "Distortion value to be added to the position inside the gradient"],
    ["base", "1983", "<tt>position</tt>"],
    ["base", "1984", "<tt>float</tt>"],
    ["base", "1985", "<tt>0.0</tt>"],
    ["base", "1986", "yes"],
    ["base", "1987", "Value driving the gradient calculation"],
    ["base", "1988", "<tt>checker_texture</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "1989", "3d color checker pattern"],
    ["base", "1990", "Name"],
    ["base", "1991", "Type"],
    ["base", "1992", "Default"],
    ["base", "1993", "Varying?"],
    ["base", "1994", "Description"],
    ["base", "1995", "<tt>uvw</tt>"],
    ["base", "1996", "<tt>texture_coordinate_info</tt>"],
    ["base", "1997", "<tt>texture_coordinate_info()</tt>"],
    ["base", "1998", "yes"],
    ["base", "1999", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2000", "<tt>color1</tt>"],
    ["base", "2001", "<tt>color</tt>"],
    ["base", "2002", "<tt>color(0)</tt>"],
    ["base", "2003", "yes"],
    ["base", "2004", "Color of the even tiles of the checker function"],
    ["base", "2005", "<tt>color2</tt>"],
    ["base", "2006", "<tt>color</tt>"],
    ["base", "2007", "<tt>color(1)</tt>"],
    ["base", "2008", "yes"],
    ["base", "2009", "Color of the odd tiles of the checker function"],
    ["base", "2010", "<tt>blur</tt>"],
    ["base", "2011", "<tt>float</tt>"],
    ["base", "2012", "<tt>0</tt>"],
    ["base", "2013", "no"],
    ["base", "2014", "Softens the border between tiles"],
    ["base", "2015", "<tt>checker_position</tt>"],
    ["base", "2016", "<tt>float</tt>"],
    ["base", "2017", "<tt>0.5</tt>"],
    ["base", "2018", "no"],
    ["base", "2019", "Ratio of division. values other than 0.5 produce non square tiles"],
    ["base", "2020", "<tt>checker_bump_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "2021", "3d bump mapping checker pattern"],
    ["base", "2022", "Name"],
    ["base", "2023", "Type"],
    ["base", "2024", "Default"],
    ["base", "2025", "Range"],
    ["base", "2026", "Varying?"],
    ["base", "2027", "Description"],
    ["base", "2028", "<tt>uvw</tt>"],
    ["base", "2029", "<tt>texture_coordinate_info</tt>"],
    ["base", "2030", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2032", "yes"],
    ["base", "2033", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2034", "<tt>factor</tt>"],
    ["base", "2035", "<tt>float</tt>"],
    ["base", "2036", "<tt>1</tt>"],
    ["base", "2038", "no"],
    ["base", "2039", "Strength of the bump mapping effect"],
    ["base", "2040", "<tt>blur</tt>"],
    ["base", "2041", "<tt>float</tt>"],
    ["base", "2042", "<tt>0.0</tt>"],
    ["base", "2043", "0.0->1.0"],
    ["base", "2044", "no"],
    ["base", "2045", "Softens the border between tiles"],
    ["base", "2046", "<tt>checker_position</tt>"],
    ["base", "2047", "<tt>float</tt>"],
    ["base", "2048", "<tt>0.5</tt>"],
    ["base", "2050", "no"],
    ["base", "2051", "Ratio of division. values other than 0.5 produce non square tiles"],
    ["base", "2052", "<tt>normal</tt>"],
    ["base", "2053", "<tt>float3</tt>"],
    ["base", "2054", "<tt>state::normal()</tt>"],
    ["base", "2056", "yes"],
    ["base", "2057", "Base normal for the bump mapping. note, apart from the default, only state:: <tt>rounded_corners</tt> is supported here and only in the material.geometry.normal slot."],
    ["base", "2058", "<tt>perlin_noise_texture</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "2059", "Color perlin noise"],
    ["base", "2060", "Name"],
    ["base", "2061", "Type"],
    ["base", "2062", "Default"],
    ["base", "2063", "Range"],
    ["base", "2064", "Varying?"],
    ["base", "2065", "Description"],
    ["base", "2066", "<tt>uvw</tt>"],
    ["base", "2067", "<tt>texture_coordinate_info</tt>"],
    ["base", "2068", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2070", "yes"],
    ["base", "2071", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2072", "<tt>color1</tt>"],
    ["base", "2073", "<tt>color</tt>"],
    ["base", "2074", "<tt>color(0)</tt>"],
    ["base", "2076", "yes"],
    ["base", "2077", "The perlin noise function will blend between this color and <tt>color2</tt>"],
    ["base", "2078", "<tt>color2</tt>"],
    ["base", "2079", "<tt>color</tt>"],
    ["base", "2080", "<tt>color(1)</tt>"],
    ["base", "2082", "yes"],
    ["base", "2083", "The perlin noise function will blend between <tt>color1</tt> and this color"],
    ["base", "2084", "<tt>size</tt>"],
    ["base", "2085", "<tt>float</tt>"],
    ["base", "2086", "<tt>1.0</tt>"],
    ["base", "2088", "no"],
    ["base", "2089", "Size of the biggest feature of the pattern"],
    ["base", "2090", "<tt>apply_marble</tt>"],
    ["base", "2091", "<tt>bool</tt>"],
    ["base", "2092", "<tt>false</tt>"],
    ["base", "2094", "no"],
    ["base", "2095", "Triggers a modification to make the pattern have a marble like appearance (cosine)"],
    ["base", "2096", "<tt>apply_dent</tt>"],
    ["base", "2097", "<tt>bool</tt>"],
    ["base", "2098", "<tt>false</tt>"],
    ["base", "2100", "no"],
    ["base", "2101", "Raises the output of the function to the power of 3"],
    ["base", "2102", "<tt>noise_phase</tt>"],
    ["base", "2103", "<tt>float</tt>"],
    ["base", "2104", "<tt>0.0</tt>"],
    ["base", "2106", "no"],
    ["base", "2107", "Controls the 4th dimension of the function (can be time in animations)"],
    ["base", "2108", "<tt>noise_levels</tt>"],
    ["base", "2109", "<tt>int</tt>"],
    ["base", "2110", "<tt>1</tt>"],
    ["base", "2112", "no"],
    ["base", "2113", "Number of octaves to of perlin to sum up"],
    ["base", "2114", "<tt>absolute_noise</tt>"],
    ["base", "2115", "<tt>bool</tt>"],
    ["base", "2116", "<tt>false</tt>"],
    ["base", "2118", "no"],
    ["base", "2119", "If set to true, the appearance of the pattern will be more \"billowing\" and \"turbulent\""],
    ["base", "2120", "<tt>ridged_noise</tt>"],
    ["base", "2121", "<tt>bool</tt>"],
    ["base", "2122", "<tt>false</tt>"],
    ["base", "2124", "no"],
    ["base", "2125", "If set to true, the appearance of the pattern will be more \"electrical\""],
    ["base", "2126", "<tt>noise_distortion</tt>"],
    ["base", "2127", "<tt>float3</tt>"],
    ["base", "2128", "<tt>float3(0.0 )</tt>"],
    ["base", "2130", "no"],
    ["base", "2131", "Weight of additional noise turbulence"],
    ["base", "2132", "<tt>noise_threshold_high</tt>"],
    ["base", "2133", "<tt>float</tt>"],
    ["base", "2134", "<tt>1.0</tt>"],
    ["base", "2135", "0.0->1.0"],
    ["base", "2136", "no"],
    ["base", "2137", "Noise values greater then <tt>noise_threshold_high</tt> are mapped to <tt>color1</tt>"],
    ["base", "2138", "<tt>noise_threshold_low</tt>"],
    ["base", "2139", "<tt>float</tt>"],
    ["base", "2140", "<tt>0.0</tt>"],
    ["base", "2141", "0.0->1.0"],
    ["base", "2142", "no"],
    ["base", "2143", "Noise values greater then <tt>noise_threshold_low</tt> are mapped to <tt>color2</tt>"],
    ["base", "2144", "<tt>noise_bands</tt>"],
    ["base", "2145", "<tt>float</tt>"],
    ["base", "2146", "<tt>1.0</tt>"],
    ["base", "2148", "no"],
    ["base", "2149", "Creates a \"tree ring\" like banding effect"],
    ["base", "2150", "<tt>perlin_noise_bump_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "2151", "Bump-mapping perlin noise"],
    ["base", "2152", "Name"],
    ["base", "2153", "Type"],
    ["base", "2154", "Default"],
    ["base", "2155", "Range"],
    ["base", "2156", "Varying?"],
    ["base", "2157", "Description"],
    ["base", "2158", "<tt>uvw</tt>"],
    ["base", "2159", "<tt>texture_coordinate_info</tt>"],
    ["base", "2160", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2162", "yes"],
    ["base", "2163", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2164", "<tt>factor</tt>"],
    ["base", "2165", "<tt>float</tt>"],
    ["base", "2166", "<tt>1.0</tt>"],
    ["base", "2168", "no"],
    ["base", "2169", "Strength of the bump mapping effect"],
    ["base", "2170", "<tt>size</tt>"],
    ["base", "2171", "<tt>float</tt>"],
    ["base", "2172", "<tt>1.0</tt>"],
    ["base", "2174", "no"],
    ["base", "2175", "Size of the biggest feature of the pattern"],
    ["base", "2176", "<tt>apply_marble</tt>"],
    ["base", "2177", "<tt>bool</tt>"],
    ["base", "2178", "<tt>false</tt>"],
    ["base", "2180", "no"],
    ["base", "2181", "Triggers a modification to make the pattern have a marble like appearance (cosine)"],
    ["base", "2182", "<tt>apply_dent</tt>"],
    ["base", "2183", "<tt>bool</tt>"],
    ["base", "2184", "<tt>false</tt>"],
    ["base", "2186", "no"],
    ["base", "2187", "Raises the output of the function to the power of 3"],
    ["base", "2188", "<tt>noise_phase</tt>"],
    ["base", "2189", "<tt>float</tt>"],
    ["base", "2190", "<tt>0.0</tt>"],
    ["base", "2192", "no"],
    ["base", "2193", "Controls the 4th dimension of the function"],
    ["base", "2194", "<tt>noise_levels</tt>"],
    ["base", "2195", "<tt>int</tt>"],
    ["base", "2196", "<tt>1</tt>"],
    ["base", "2198", "no"],
    ["base", "2199", "Number of octaves to of perlin to sum up"],
    ["base", "2200", "<tt>absolute_noise</tt>"],
    ["base", "2201", "<tt>bool</tt>"],
    ["base", "2202", "<tt>false</tt>"],
    ["base", "2204", "no"],
    ["base", "2205", "If set to true, the appearance of the pattern will be more \"billowing\" and \"turbulent\""],
    ["base", "2206", "<tt>ridged_noise</tt>"],
    ["base", "2207", "<tt>bool</tt>"],
    ["base", "2208", "<tt>false</tt>"],
    ["base", "2210", "no"],
    ["base", "2211", "If set to true, the appearance of the pattern will be more \"electrical\""],
    ["base", "2212", "<tt>noise_distortion</tt>"],
    ["base", "2213", "<tt>float3</tt>"],
    ["base", "2214", "<tt>float3(0.0 )</tt>"],
    ["base", "2216", "no"],
    ["base", "2217", "Weight of additional noise turbulence"],
    ["base", "2218", "<tt>noise_threshold_high</tt>"],
    ["base", "2219", "<tt>float</tt>"],
    ["base", "2220", "<tt>1.0</tt>"],
    ["base", "2221", "0.0->1.0"],
    ["base", "2222", "no"],
    ["base", "2223", "Noise values greater then <tt>noise_threshold_high</tt> are mapped to the maximum bump height"],
    ["base", "2224", "<tt>noise_threshold_low</tt>"],
    ["base", "2225", "<tt>float</tt>"],
    ["base", "2226", "<tt>0.0</tt>"],
    ["base", "2227", "0.0->1.0"],
    ["base", "2228", "no"],
    ["base", "2229", "Noise values greater then <tt>noise_threshold_low</tt> are mapped to the minimum bump height"],
    ["base", "2230", "<tt>noise_bands</tt>"],
    ["base", "2231", "<tt>float</tt>"],
    ["base", "2232", "<tt>1.0</tt>"],
    ["base", "2234", "no"],
    ["base", "2235", "Creates a \"tree ring\" like banding effect"],
    ["base", "2236", "<tt>normal</tt>"],
    ["base", "2237", "<tt>float3</tt>"],
    ["base", "2238", "<tt>state::normal()</tt>"],
    ["base", "2240", "yes"],
    ["base", "2241", "Base normal for the bump mapping. note, apart from the default, only state:: <tt>rounded_corners</tt> is supported here and only in the material.geometry.normal slot."],
    ["base", "2242", "<tt>worley_noise_texture</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "2243", "Color worley noise"],
    ["base", "2244", "Name"],
    ["base", "2245", "Type"],
    ["base", "2246", "Default"],
    ["base", "2247", "Range"],
    ["base", "2248", "Varying?"],
    ["base", "2249", "Description"],
    ["base", "2250", "<tt>uvw</tt>"],
    ["base", "2251", "<tt>texture_coordinate_info</tt>"],
    ["base", "2252", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2254", "yes"],
    ["base", "2255", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2256", "<tt>color1</tt>"],
    ["base", "2257", "<tt>color</tt>"],
    ["base", "2258", "<tt>color(0)</tt>"],
    ["base", "2260", "yes"],
    ["base", "2261", "The worley noise function will blend between this color and <tt>color2</tt>"],
    ["base", "2262", "<tt>color2</tt>"],
    ["base", "2263", "<tt>color</tt>"],
    ["base", "2264", "<tt>color(1)</tt>"],
    ["base", "2266", "yes"],
    ["base", "2267", "The worley noise function will blend between <tt>color1</tt> and this color"],
    ["base", "2268", "<tt>size</tt>"],
    ["base", "2269", "<tt>float</tt>"],
    ["base", "2270", "<tt>1.0</tt>"],
    ["base", "2272", "no"],
    ["base", "2273", "Size of the biggest feature of the pattern"],
    ["base", "2274", "<tt>mode</tt>"],
    ["base", "2275", "<tt>int</tt>"],
    ["base", "2276", "<tt>0</tt>"],
    ["base", "2277", "0->11"],
    ["base", "2278", "no"],
    ["base", "2279", "Output function used to modify the noise result (0.0.11)"],
    ["base", "2280", "<tt>metric</tt>"],
    ["base", "2281", "<tt>int</tt>"],
    ["base", "2282", "<tt>0</tt>"],
    ["base", "2283", "0->2"],
    ["base", "2284", "no"],
    ["base", "2285", "Metric used in the noise function (0: euclidean, 1: manhattan, 2: chebyshev)"],
    ["base", "2286", "<tt>apply_marble</tt>"],
    ["base", "2287", "<tt>bool</tt>"],
    ["base", "2288", "<tt>false</tt>"],
    ["base", "2290", "no"],
    ["base", "2291", "Triggers a modification to make the pattern have a marble like appearance (cosine)"],
    ["base", "2292", "<tt>apply_dent</tt>"],
    ["base", "2293", "<tt>bool</tt>"],
    ["base", "2294", "<tt>false</tt>"],
    ["base", "2296", "no"],
    ["base", "2297", "Raises the output of the function to the power of 3"],
    ["base", "2298", "<tt>noise_distortion</tt>"],
    ["base", "2299", "<tt>float3</tt>"],
    ["base", "2300", "<tt>float3(0.0 )</tt>"],
    ["base", "2302", "no"],
    ["base", "2303", "Weight of additional noise turbulence"],
    ["base", "2304", "<tt>noise_threshold_high</tt>"],
    ["base", "2305", "<tt>float</tt>"],
    ["base", "2306", "<tt>1.0</tt>"],
    ["base", "2307", "0.0->1.0"],
    ["base", "2308", "no"],
    ["base", "2309", "Noise values greater then <tt>noise_threshold_high</tt> are mapped to <tt>color1</tt>"],
    ["base", "2310", "<tt>noise_threshold_low</tt>"],
    ["base", "2311", "<tt>float</tt>"],
    ["base", "2312", "<tt>0.0</tt>"],
    ["base", "2313", "0.0->1.0"],
    ["base", "2314", "no"],
    ["base", "2315", "Noise values greater then <tt>noise_threshold_low</tt> are mapped to <tt>color2</tt>"],
    ["base", "2316", "<tt>noise_bands</tt>"],
    ["base", "2317", "<tt>float</tt>"],
    ["base", "2318", "<tt>1.0</tt>"],
    ["base", "2320", "no"],
    ["base", "2321", "Creates a \"tree ring\" like banding effect"],
    ["base", "2322", "<tt>step_threshold</tt>"],
    ["base", "2323", "<tt>float</tt>"],
    ["base", "2324", "<tt>0.2</tt>"],
    ["base", "2326", "no"],
    ["base", "2327", "Used only in mode 3"],
    ["base", "2328", "<tt>edge</tt>"],
    ["base", "2329", "<tt>float</tt>"],
    ["base", "2330", "<tt>1.0</tt>"],
    ["base", "2331", "0.0->1.0"],
    ["base", "2332", "no"],
    ["base", "2333", "Smoothness of noise"],
    ["base", "2334", "<tt>worley_noise_bump_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "2335", "Bump-mapping worley noise"],
    ["base", "2336", "Name"],
    ["base", "2337", "Type"],
    ["base", "2338", "Default"],
    ["base", "2339", "Range"],
    ["base", "2340", "Varying?"],
    ["base", "2341", "Description"],
    ["base", "2342", "<tt>uvw</tt>"],
    ["base", "2343", "<tt>texture_coordinate_info</tt>"],
    ["base", "2344", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2346", "yes"],
    ["base", "2347", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2348", "<tt>factor</tt>"],
    ["base", "2349", "<tt>float</tt>"],
    ["base", "2350", "<tt>1.0</tt>"],
    ["base", "2352", "no"],
    ["base", "2353", "Strength of the bump mapping effect"],
    ["base", "2354", "<tt>size</tt>"],
    ["base", "2355", "<tt>float</tt>"],
    ["base", "2356", "<tt>1.0</tt>"],
    ["base", "2358", "no"],
    ["base", "2359", "Size of the biggest feature of the pattern"],
    ["base", "2360", "<tt>mode</tt>"],
    ["base", "2361", "<tt>int</tt>"],
    ["base", "2362", "<tt>0</tt>"],
    ["base", "2363", "0->11"],
    ["base", "2364", "no"],
    ["base", "2365", "Output function used to modify the noise result (0.0.11)"],
    ["base", "2366", "<tt>metric</tt>"],
    ["base", "2367", "<tt>int</tt>"],
    ["base", "2368", "<tt>0</tt>"],
    ["base", "2369", "0->2"],
    ["base", "2370", "no"],
    ["base", "2371", "Metric used in the noise function (0: euclidean, 1: manhattan, 2: chebyshev)"],
    ["base", "2372", "<tt>apply_marble</tt>"],
    ["base", "2373", "<tt>bool</tt>"],
    ["base", "2374", "<tt>false</tt>"],
    ["base", "2376", "no"],
    ["base", "2377", "Triggers a modification to make the pattern have a marble like appearance (cosine)"],
    ["base", "2378", "<tt>apply_dent</tt>"],
    ["base", "2379", "<tt>bool</tt>"],
    ["base", "2380", "<tt>false</tt>"],
    ["base", "2382", "no"],
    ["base", "2383", "Raises the output of the function to the power of 3"],
    ["base", "2384", "<tt>noise_distortion</tt>"],
    ["base", "2385", "<tt>float3</tt>"],
    ["base", "2386", "<tt>float3(0.0 )</tt>"],
    ["base", "2388", "no"],
    ["base", "2389", "Weight of additional noise turbulence"],
    ["base", "2390", "<tt>noise_threshold_high</tt>"],
    ["base", "2391", "<tt>float</tt>"],
    ["base", "2392", "<tt>1.0</tt>"],
    ["base", "2393", "0.0->1.0"],
    ["base", "2394", "no"],
    ["base", "2395", "Noise values greater then <tt>noise_threshold_high</tt> are mapped to the maximum bump height"],
    ["base", "2396", "<tt>noise_threshold_low</tt>"],
    ["base", "2397", "<tt>float</tt>"],
    ["base", "2398", "<tt>0.0</tt>"],
    ["base", "2399", "0.0->1.0"],
    ["base", "2400", "no"],
    ["base", "2401", "Noise values greater then <tt>noise_threshold_low</tt> are mapped to the minimum bump height"],
    ["base", "2402", "<tt>noise_bands</tt>"],
    ["base", "2403", "<tt>float</tt>"],
    ["base", "2404", "<tt>1.0</tt>"],
    ["base", "2406", "no"],
    ["base", "2407", "Creates a \"tree ring\" like banding effect"],
    ["base", "2408", "<tt>step_threshold</tt>"],
    ["base", "2409", "<tt>float</tt>"],
    ["base", "2410", "<tt>0.2</tt>"],
    ["base", "2412", "no"],
    ["base", "2413", "Used only in mode 3"],
    ["base", "2414", "<tt>edge</tt>"],
    ["base", "2415", "<tt>float</tt>"],
    ["base", "2416", "<tt>1.0</tt>"],
    ["base", "2417", "0.0->1.0"],
    ["base", "2418", "no"],
    ["base", "2419", "Smoothness of noise"],
    ["base", "2420", "<tt>normal</tt>"],
    ["base", "2421", "<tt>float3</tt>"],
    ["base", "2422", "<tt>state::normal()</tt>"],
    ["base", "2424", "yes"],
    ["base", "2425", "Base normal for the bump mapping. note, apart from the default, only state:: <tt>rounded_corners</tt> is supported here and only in the material.geometry.normal slot."],
    ["base", "2426", "<tt>flow_noise_texture</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "2427", "Color perlin flow noise"],
    ["base", "2428", "Name"],
    ["base", "2429", "Type"],
    ["base", "2430", "Default"],
    ["base", "2431", "Varying?"],
    ["base", "2432", "Description"],
    ["base", "2433", "<tt>uvw</tt>"],
    ["base", "2434", "<tt>texture_coordinate_info</tt>"],
    ["base", "2435", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2436", "yes"],
    ["base", "2437", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2438", "<tt>color1</tt>"],
    ["base", "2439", "<tt>color</tt>"],
    ["base", "2440", "<tt>color(0)</tt>"],
    ["base", "2441", "yes"],
    ["base", "2442", "The flow noise function will blend between this color and <tt>color2</tt>"],
    ["base", "2443", "<tt>color2</tt>"],
    ["base", "2444", "<tt>color</tt>"],
    ["base", "2445", "<tt>color(1)</tt>"],
    ["base", "2446", "yes"],
    ["base", "2447", "The flow noise function will blend between <tt>color1</tt> and this color"],
    ["base", "2448", "<tt>size</tt>"],
    ["base", "2449", "<tt>float</tt>"],
    ["base", "2450", "<tt>1.0</tt>"],
    ["base", "2451", "no"],
    ["base", "2452", "Size of the biggest feature of the pattern"],
    ["base", "2453", "<tt>phase</tt>"],
    ["base", "2454", "<tt>float</tt>"],
    ["base", "2455", "<tt>0.0</tt>"],
    ["base", "2456", "no"],
    ["base", "2457", "Controls the 3rd dimension of the function"],
    ["base", "2458", "<tt>levels</tt>"],
    ["base", "2459", "<tt>int</tt>"],
    ["base", "2460", "<tt>1</tt>"],
    ["base", "2461", "no"],
    ["base", "2462", "Number of octaves to of flow noise to sum up"],
    ["base", "2463", "<tt>absolute_noise</tt>"],
    ["base", "2464", "<tt>bool</tt>"],
    ["base", "2465", "<tt>false</tt>"],
    ["base", "2466", "no"],
    ["base", "2467", "If set to true, the appearance of the pattern will be more \"billowing\" and \"turbulent\""],
    ["base", "2468", "<tt>level_gain</tt>"],
    ["base", "2469", "<tt>float</tt>"],
    ["base", "2470", "<tt>0.5</tt>"],
    ["base", "2471", "no"],
    ["base", "2472", "If multiple levels are used, <tt>level_gain</tt> specifies a weighting factor for subsequent levels"],
    ["base", "2473", "<tt>level_scale</tt>"],
    ["base", "2474", "<tt>float</tt>"],
    ["base", "2475", "<tt>2.0</tt>"],
    ["base", "2476", "no"],
    ["base", "2477", "If multiple levels are used, <tt>level_scale</tt> specifies a global scaling factor for subsequent levels"],
    ["base", "2478", "<tt>level_progressive_u_scale</tt>"],
    ["base", "2479", "<tt>float</tt>"],
    ["base", "2480", "<tt>1.0</tt>"],
    ["base", "2481", "no"],
    ["base", "2482", "If multiple levels are used, <tt>level_progressive_u_scale</tt> specifies an additional scaling factor in the <i>u </i> direction"],
    ["base", "2483", "<tt>level_progressive_v_motion</tt>"],
    ["base", "2484", "<tt>float</tt>"],
    ["base", "2485", "<tt>0.0</tt>"],
    ["base", "2486", "no"],
    ["base", "2487", "If multiple levels are used, <tt>level_progressive_v_motion</tt> specifies an offset for subsequent levels in the <i>v </i> direction"],
    ["base", "2488", "<tt>flow_noise_bump_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "2489", "Bump-mapping flow noise"],
    ["base", "2490", "Name"],
    ["base", "2491", "Type"],
    ["base", "2492", "Default"],
    ["base", "2493", "Varying?"],
    ["base", "2494", "Description"],
    ["base", "2495", "<tt>uvw</tt>"],
    ["base", "2496", "<tt>texture_coordinate_info</tt>"],
    ["base", "2497", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2498", "yes"],
    ["base", "2499", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2500", "<tt>factor</tt>"],
    ["base", "2501", "<tt>float</tt>"],
    ["base", "2502", "<tt>1.0</tt>"],
    ["base", "2503", "no"],
    ["base", "2504", "Strength of the bump mapping effect"],
    ["base", "2505", "<tt>size</tt>"],
    ["base", "2506", "<tt>float</tt>"],
    ["base", "2507", "<tt>1.0</tt>"],
    ["base", "2508", "no"],
    ["base", "2509", "Size of the biggest feature of the pattern"],
    ["base", "2510", "<tt>phase</tt>"],
    ["base", "2511", "<tt>float</tt>"],
    ["base", "2512", "<tt>0.0</tt>"],
    ["base", "2513", "no"],
    ["base", "2514", "Controls the 4th dimension of the function"],
    ["base", "2515", "<tt>levels</tt>"],
    ["base", "2516", "<tt>int</tt>"],
    ["base", "2517", "<tt>1</tt>"],
    ["base", "2518", "no"],
    ["base", "2519", "Number of octaves to of perlin to sum up"],
    ["base", "2520", "<tt>absolute_noise</tt>"],
    ["base", "2521", "<tt>bool</tt>"],
    ["base", "2522", "<tt>false</tt>"],
    ["base", "2523", "no"],
    ["base", "2524", "If set to true, the appearance of the pattern will be more \"billowing\" and \"turbulent\""],
    ["base", "2525", "<tt>level_gain</tt>"],
    ["base", "2526", "<tt>float</tt>"],
    ["base", "2527", "<tt>0.5</tt>"],
    ["base", "2528", "no"],
    ["base", "2529", "If multiple levels are used, <tt>level_gain</tt> specifies a weighting factor for subsequent levels"],
    ["base", "2530", "<tt>level_scale</tt>"],
    ["base", "2531", "<tt>float</tt>"],
    ["base", "2532", "<tt>2.0</tt>"],
    ["base", "2533", "no"],
    ["base", "2534", "If multiple levels are used, <tt>level_scale</tt> specifies a global scaling factor for subsequent levels"],
    ["base", "2535", "<tt>level_progressive_u_scale</tt>"],
    ["base", "2536", "<tt>float</tt>"],
    ["base", "2537", "<tt>1.0</tt>"],
    ["base", "2538", "no"],
    ["base", "2539", "If multiple levels are used, <tt>level_progressive_u_scale</tt> specifies an additional scaling factor in the <i>u </i> direction"],
    ["base", "2540", "<tt>level_progressive_v_motion</tt>"],
    ["base", "2541", "<tt>float</tt>"],
    ["base", "2542", "<tt>0.0</tt>"],
    ["base", "2543", "no"],
    ["base", "2544", "If multiple levels are used, <tt>level_progressive_v_motion</tt> specifies an offset for subsequent levels in the <i>v </i> direction"],
    ["base", "2545", "<tt>normal</tt>"],
    ["base", "2546", "<tt>float3</tt>"],
    ["base", "2547", "<tt>state::normal()</tt>"],
    ["base", "2548", "yes"],
    ["base", "2549", "Base normal for the bump mapping. note, apart from the default, only state:: <tt>rounded_corners</tt> is supported here and only in the material.geometry.normal slot."],
    ["base", "2550", "<tt>flake_noise_texture</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "2551", "Flake noise"],
    ["base", "2552", "Name"],
    ["base", "2553", "Type"],
    ["base", "2554", "Default"],
    ["base", "2555", "Range"],
    ["base", "2556", "Varying?"],
    ["base", "2557", "Description"],
    ["base", "2558", "<tt>uvw</tt>"],
    ["base", "2559", "<tt>texture_coordinate_info</tt>"],
    ["base", "2560", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2562", "yes"],
    ["base", "2563", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2564", "<tt>intensity</tt>"],
    ["base", "2565", "<tt>float</tt>"],
    ["base", "2566", "<tt>1.0</tt>"],
    ["base", "2567", "0.0->1.0"],
    ["base", "2568", "no"],
    ["base", "2569", "Specifies the maximum reflectivity of any flake"],
    ["base", "2570", "<tt>scale</tt>"],
    ["base", "2571", "<tt>float</tt>"],
    ["base", "2572", "<tt>1.0</tt>"],
    ["base", "2574", "no"],
    ["base", "2575", "Size of the features of the pattern"],
    ["base", "2576", "<tt>density</tt>"],
    ["base", "2577", "<tt>float</tt>"],
    ["base", "2578", "<tt>1.0</tt>"],
    ["base", "2580", "no"],
    ["base", "2581", "Controls the amount of flakes in the substrate. the higher the number, the bigger is the space between flakes"],
    ["base", "2582", "<tt>noise_type</tt>"],
    ["base", "2583", "<tt>int</tt>"],
    ["base", "2584", "<tt>0</tt>"],
    ["base", "2585", "0->1"],
    ["base", "2586", "no"],
    ["base", "2587", "Selects the noise type (0: classic, 1: worley)"],
    ["base", "2588", "<tt>maximum_size</tt>"],
    ["base", "2589", "<tt>float</tt>"],
    ["base", "2590", "<tt>1.0</tt>"],
    ["base", "2592", "no"],
    ["base", "2593", "Controls the shape of flakes in the secondary noise mode (worley)"],
    ["base", "2594", "<tt>metric</tt>"],
    ["base", "2595", "<tt>int</tt>"],
    ["base", "2596", "<tt>0</tt>"],
    ["base", "2597", "0->2"],
    ["base", "2598", "no"],
    ["base", "2599", "Metric used in the secondary noise mode (worley: 0: euclidean, 1: manhattan, 2: chebyshev)"],
    ["base", "2600", "<tt>flake_noise_bump_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "2601", "Bump-mapping flake noise"],
    ["base", "2602", "Name"],
    ["base", "2603", "Type"],
    ["base", "2604", "Default"],
    ["base", "2605", "Range"],
    ["base", "2606", "Varying?"],
    ["base", "2607", "Description"],
    ["base", "2608", "<tt>uvw</tt>"],
    ["base", "2609", "<tt>texture_coordinate_info</tt>"],
    ["base", "2610", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2612", "yes"],
    ["base", "2613", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2614", "<tt>scale</tt>"],
    ["base", "2615", "<tt>float</tt>"],
    ["base", "2616", "<tt>1.0</tt>"],
    ["base", "2618", "no"],
    ["base", "2619", "Size of the features of the pattern"],
    ["base", "2620", "<tt>strength</tt>"],
    ["base", "2621", "<tt>float</tt>"],
    ["base", "2622", "<tt>1.0</tt>"],
    ["base", "2624", "no"],
    ["base", "2625", "Controls the randomness of the flake orientation"],
    ["base", "2626", "<tt>noise_type</tt>"],
    ["base", "2627", "<tt>int</tt>"],
    ["base", "2628", "<tt>0</tt>"],
    ["base", "2629", "0->1"],
    ["base", "2630", "no"],
    ["base", "2631", "Selects the noise type (0: classic, 1: worley)"],
    ["base", "2632", "<tt>maximum_size</tt>"],
    ["base", "2633", "<tt>float</tt>"],
    ["base", "2634", "<tt>1.0</tt>"],
    ["base", "2636", "no"],
    ["base", "2637", "Controls the shape of flakes in the secondary noise mode (worley)"],
    ["base", "2638", "<tt>metric</tt>"],
    ["base", "2639", "<tt>int</tt>"],
    ["base", "2640", "<tt>0</tt>"],
    ["base", "2641", "0->2"],
    ["base", "2642", "no"],
    ["base", "2643", "Metric used in the secondary noise mode (worley: 0: euclidean, 1: manhattan, 2: chebyshev)"],
    ["base", "2644", "<tt>normal</tt>"],
    ["base", "2645", "<tt>float3</tt>"],
    ["base", "2646", "<tt>state::normal()</tt>"],
    ["base", "2648", "yes"],
    ["base", "2649", "Base normal for the bump mapping. note, apart from the default, only state:: <tt>rounded_corners</tt> is supported here and only in the material.geometry.normal slot."],
    ["base", "2650", "<tt>tile_texture</tt><i>returns </i><tt>texture_return</tt>"],
    ["base", "2651", "Color tiling generator"],
    ["base", "2652", "Name"],
    ["base", "2653", "Type"],
    ["base", "2654", "Default"],
    ["base", "2655", "Range"],
    ["base", "2656", "Varying?"],
    ["base", "2657", "Description"],
    ["base", "2658", "<tt>uvw</tt>"],
    ["base", "2659", "<tt>texture_coordinate_info</tt>"],
    ["base", "2660", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2662", "yes"],
    ["base", "2663", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2664", "<tt>tile_color</tt>"],
    ["base", "2665", "<tt>color</tt>"],
    ["base", "2666", "<tt>color(0)</tt>"],
    ["base", "2668", "yes"],
    ["base", "2669", "Color of \"bricks\" in the function"],
    ["base", "2670", "<tt>grout_color</tt>"],
    ["base", "2671", "<tt>color</tt>"],
    ["base", "2672", "<tt>color(1)</tt>"],
    ["base", "2674", "yes"],
    ["base", "2675", "Color of \"grout\" between the \"bricks\" in the function"],
    ["base", "2676", "<tt>number_of_rows</tt>"],
    ["base", "2677", "<tt>float</tt>"],
    ["base", "2678", "<tt>4.0</tt>"],
    ["base", "2680", "no"],
    ["base", "2681", "Number of tile rows in the 0-1 texturing domain"],
    ["base", "2682", "<tt>number_of_columns</tt>"],
    ["base", "2683", "<tt>float</tt>"],
    ["base", "2684", "<tt>4.0</tt>"],
    ["base", "2686", "no"],
    ["base", "2687", "Number of tile columns in the 0-1 texturing domain"],
    ["base", "2688", "<tt>grout_width</tt>"],
    ["base", "2689", "<tt>float</tt>"],
    ["base", "2690", "<tt>0.02</tt>"],
    ["base", "2691", "0.0->1.0"],
    ["base", "2692", "no"],
    ["base", "2693", "Absolute width of vertical grout lines"],
    ["base", "2694", "<tt>grout_height</tt>"],
    ["base", "2695", "<tt>float</tt>"],
    ["base", "2696", "<tt>0.02</tt>"],
    ["base", "2697", "0.0->1.0"],
    ["base", "2698", "no"],
    ["base", "2699", "Absolute height of horizontal grout lines"],
    ["base", "2700", "<tt>grout_roughness</tt>"],
    ["base", "2701", "<tt>float</tt>"],
    ["base", "2702", "<tt>0.0</tt>"],
    ["base", "2703", "0.0->1.0"],
    ["base", "2704", "no"],
    ["base", "2705", "Amount of noise added to grout size"],
    ["base", "2706", "<tt>missing_tile_amount</tt>"],
    ["base", "2707", "<tt>float</tt>"],
    ["base", "2708", "<tt>0.0</tt>"],
    ["base", "2709", "0.0->1.0"],
    ["base", "2710", "no"],
    ["base", "2711", "Number of tiles that will end up as grout, rather than as a tile (\"holes\"). values are [0,1]."],
    ["base", "2712", "<tt>tile_brightness_variation</tt>"],
    ["base", "2713", "<tt>float</tt>"],
    ["base", "2714", "<tt>0.0</tt>"],
    ["base", "2715", "0.0->1.0"],
    ["base", "2716", "no"],
    ["base", "2717", "Randomization factor to the brightness of the tile color"],
    ["base", "2718", "<tt>seed</tt>"],
    ["base", "2719", "<tt>float</tt>"],
    ["base", "2720", "<tt>2.284</tt>"],
    ["base", "2722", "no"],
    ["base", "2723", "Seeding number for random number generator controlling tile randomization effects"],
    ["base", "2724", "<tt>special_row_index</tt>"],
    ["base", "2725", "<tt>int</tt>"],
    ["base", "2726", "<tt>1</tt>"],
    ["base", "2728", "no"],
    ["base", "2729", "Every nth row, width of tiles is modified. set nth all to 1 to disable. never set the nth row or column to 0.0"],
    ["base", "2730", "<tt>special_row_width_factor</tt>"],
    ["base", "2731", "<tt>float</tt>"],
    ["base", "2732", "<tt>1.0</tt>"],
    ["base", "2734", "no"],
    ["base", "2735", "Change of width for tiles identified through <tt>special_row_index</tt>"],
    ["base", "2736", "<tt>special_column_index</tt>"],
    ["base", "2737", "<tt>int</tt>"],
    ["base", "2738", "<tt>1</tt>"],
    ["base", "2740", "no"],
    ["base", "2741", "Every nth column, height of tiles is modified. set nth all to 1 to disable. never set the nth row or column to 0.0"],
    ["base", "2742", "<tt>special_column_height_factor</tt>"],
    ["base", "2743", "<tt>float</tt>"],
    ["base", "2744", "<tt>1.0</tt>"],
    ["base", "2746", "no"],
    ["base", "2747", "Change of height for tiles identified through <tt>special_column_index</tt>"],
    ["base", "2748", "<tt>odd_row_offset</tt>"],
    ["base", "2749", "<tt>float</tt>"],
    ["base", "2750", "<tt>0.5</tt>"],
    ["base", "2751", "0.0->1.0"],
    ["base", "2752", "no"],
    ["base", "2753", "Controls bonding pattern. 0 will result in a \"stack bond\", 0.5 a \"running bond\""],
    ["base", "2754", "<tt>random_row_offset</tt>"],
    ["base", "2755", "<tt>float</tt>"],
    ["base", "2756", "<tt>0.0</tt>"],
    ["base", "2757", "0.0->1.0"],
    ["base", "2758", "no"],
    ["base", "2759", "Randomization factor for <tt>odd_row_offset</tt>"],
    ["base", "2760", "<tt>tile_bump_texture</tt><i>returns </i><tt>float3</tt>"],
    ["base", "2761", "Bump-mapping tiling generator"],
    ["base", "2762", "Name"],
    ["base", "2763", "Type"],
    ["base", "2764", "Default"],
    ["base", "2765", "Range"],
    ["base", "2766", "Varying?"],
    ["base", "2767", "Description"],
    ["base", "2768", "<tt>uvw</tt>"],
    ["base", "2769", "<tt>texture_coordinate_info</tt>"],
    ["base", "2770", "<tt>texture_coordinate_info()</tt>"],
    ["base", "2772", "yes"],
    ["base", "2773", "Parameterization to be used for texture mapping. defaults to texture channel <tt>0</tt>."],
    ["base", "2774", "<tt>factor</tt>"],
    ["base", "2775", "<tt>float</tt>"],
    ["base", "2776", "<tt>1</tt>"],
    ["base", "2778", "no"],
    ["base", "2779", "Strength of the bump mapping effect"],
    ["base", "2780", "<tt>number_of_rows</tt>"],
    ["base", "2781", "<tt>float</tt>"],
    ["base", "2782", "<tt>4.0</tt>"],
    ["base", "2784", "no"],
    ["base", "2785", "Number of tile rows in the 0-1 texturing domain"],
    ["base", "2786", "<tt>number_of_columns</tt>"],
    ["base", "2787", "<tt>float</tt>"],
    ["base", "2788", "<tt>4.0</tt>"],
    ["base", "2790", "no"],
    ["base", "2791", "Number of tile columns in the 0-1 texturing domain"],
    ["base", "2792", "<tt>grout_width</tt>"],
    ["base", "2793", "<tt>float</tt>"],
    ["base", "2794", "<tt>0.02</tt>"],
    ["base", "2795", "0.0->1.0"],
    ["base", "2796", "no"],
    ["base", "2797", "Absolute width of vertical grout lines"],
    ["base", "2798", "<tt>grout_height</tt>"],
    ["base", "2799", "<tt>float</tt>"],
    ["base", "2800", "<tt>0.02</tt>"],
    ["base", "2801", "0.0->1.0"],
    ["base", "2802", "no"],
    ["base", "2803", "Absolute height of horizontal grout lines"],
    ["base", "2804", "<tt>grout_roughness</tt>"],
    ["base", "2805", "<tt>float</tt>"],
    ["base", "2806", "<tt>0.0</tt>"],
    ["base", "2807", "0.0->1.0"],
    ["base", "2808", "no"],
    ["base", "2809", "Amount of noise added to grout size"],
    ["base", "2810", "<tt>missing_tile_amount</tt>"],
    ["base", "2811", "<tt>float</tt>"],
    ["base", "2812", "<tt>0.0</tt>"],
    ["base", "2814", "no"],
    ["base", "2815", "Number of tiles that will end up as grout, rather than as a tile (\"holes\"). values are [0,1]."],
    ["base", "2816", "<tt>tile_brightness_variation</tt>"],
    ["base", "2817", "<tt>float</tt>"],
    ["base", "2818", "<tt>0.0</tt>"],
    ["base", "2819", "0.0->1.0"],
    ["base", "2820", "no"],
    ["base", "2821", "Randomization factor to the brightness of the tile color, will affect the bumpiness for that tile"],
    ["base", "2822", "<tt>seed</tt>"],
    ["base", "2823", "<tt>float</tt>"],
    ["base", "2824", "<tt>2.284</tt>"],
    ["base", "2826", "no"],
    ["base", "2827", "Seeding number for random number generator controlling tile randomization effects"],
    ["base", "2828", "<tt>special_row_index</tt>"],
    ["base", "2829", "<tt>int</tt>"],
    ["base", "2830", "<tt>1</tt>"],
    ["base", "2832", "no"],
    ["base", "2833", "Every nth row, width of tiles is modified. set nth all to 1 to disable. never set the nth row or column to 0.0"],
    ["base", "2834", "<tt>special_row_width_factor</tt>"],
    ["base", "2835", "<tt>float</tt>"],
    ["base", "2836", "<tt>1.0</tt>"],
    ["base", "2838", "no"],
    ["base", "2839", "Change of width for tiles identified through <tt>special_row_index</tt>"],
    ["base", "2840", "<tt>special_column_index</tt>"],
    ["base", "2841", "<tt>int</tt>"],
    ["base", "2842", "<tt>1</tt>"],
    ["base", "2844", "no"],
    ["base", "2845", "Every nth column, height of tiles is modified. set nth all to 1 to disable. never set the nth row or column to 0.0"],
    ["base", "2846", "<tt>special_column_height_factor</tt>"],
    ["base", "2847", "<tt>float</tt>"],
    ["base", "2848", "<tt>1.0</tt>"],
    ["base", "2850", "no"],
    ["base", "2851", "Change of height for tiles identified through <tt>special_column_index</tt>"],
    ["base", "2852", "<tt>odd_row_offset</tt>"],
    ["base", "2853", "<tt>float</tt>"],
    ["base", "2854", "<tt>0.5</tt>"],
    ["base", "2856", "no"],
    ["base", "2857", "Controls bonding pattern. 0 will result in a \"stack bond\", 0.5 a \"running bond\""],
    ["base", "2858", "<tt>random_row_offset</tt>"],
    ["base", "2859", "<tt>float</tt>"],
    ["base", "2860", "<tt>0.0</tt>"],
    ["base", "2861", "0.0->1.0"],
    ["base", "2862", "no"],
    ["base", "2863", "Randomization factor for <tt>odd_row_offset</tt>"],
    ["base", "2864", "<tt>normal</tt>"],
    ["base", "2865", "<tt>float3</tt>"],
    ["base", "2866", "<tt>state::normal()</tt>"],
    ["base", "2868", "yes"],
    ["base", "2869", "Base normal for the bump mapping. note, apart from the default, only state:: <tt>rounded_corners</tt> is supported here and only in the material.geometry.normal slot."],
    ["base", "2870", "<tt>anisotropy_conversion</tt><i>returns </i><tt>anisotropy_return</tt>"],
    ["base", "2871", "Convert old anisotropy controls into new ones"],
    ["base", "2872", "Name"],
    ["base", "2873", "Type"],
    ["base", "2874", "Default"],
    ["base", "2875", "Range"],
    ["base", "2876", "Varying?"],
    ["base", "2877", "Description"],
    ["base", "2878", "<tt>roughness</tt>"],
    ["base", "2879", "<tt>float</tt>"],
    ["base", "2880", "<tt>0.5</tt>"],
    ["base", "2881", "0.0->1.0"],
    ["base", "2882", "yes"],
    ["base", "2883", "The base roughness value"],
    ["base", "2884", "<tt>anisotropy</tt>"],
    ["base", "2885", "<tt>float</tt>"],
    ["base", "2886", "<tt>0.0</tt>"],
    ["base", "2888", "yes"],
    ["base", "2889", "The anisotropy of the roughness"],
    ["base", "2890", "<tt>anisotropy_rotation</tt>"],
    ["base", "2891", "<tt>float</tt>"],
    ["base", "2892", "<tt>0.0</tt>"],
    ["base", "2894", "yes"],
    ["base", "2895", "Rotation of direction of anisotropy, where 1 equals 360 degrees"],
    ["base", "2896", "<tt>tangent_u</tt>"],
    ["base", "2897", "<tt>float3</tt>"],
    ["base", "2898", "<tt>state::texture_tangent_u(0)</tt>"],
    ["base", "2900", "yes"],
    ["base", "2901", "Tangent to align the anisotropy with. <tt>coordinate_source</tt> or <tt>coordinate_projection</tt> are possible sources"],
    ["base", "2902", "<tt>mia_anisotropy_semantic</tt>"],
    ["base", "2903", "<tt>bool</tt>"],
    ["base", "2904", "<tt>false</tt>"],
    ["base", "2906", "no"],
    ["base", "2907", "Allows backwards compatibility with mia material"]
  ]]
];

var section_headers = {
  "1 Introduction": ["base", "introduction"],
  "2 Functionality overview": ["base", "functionality-overview"],
  "2.1 Texturing functions": ["base", "texturing-functions"],
  "2.2 Ancillary functions": ["base", "ancillary-functions"],
  "3 Language elements": ["base", "language-elements"],
  "4 Enums": ["base", "enums"],
  "5 Structs": ["base", "structs"],
  "6 Functions": ["base", "functions"]};
